package com.mh.user.component;

import com.alibaba.druid.sql.visitor.functions.Isnull;
import com.alibaba.fastjson.JSONObject;
import com.mh.user.config.RabbitmqConfig;
import com.mh.user.model.QueueParam;
import com.mh.user.utils.AnalysisReceiveOrder485;
import com.rabbitmq.client.AMQP;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.impl.AMQImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.log4j.Logger;
import org.springframework.amqp.core.ExchangeTypes;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Exchange;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.QueueBinding;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Component;

import java.io.IOException;

/**
 * 队列消费接收消息
 */
@Component
public class ReceiveHandler {

    private static final Logger log = Logger.getLogger(ReceiveHandler.class);
    //监听队列
//    @RabbitListener(bindings = @QueueBinding(
//            value = @Queue(value = "queue_zjjd", durable = "true"),
//            exchange = @Exchange(
//                    value = "topic.exchange",
//                    ignoreDeclarationExceptions = "true",
//                    type = ExchangeTypes.TOPIC
//            ),
//            key = {"topic.#.zjjd.#"}),ackMode = "MANUAL")
    @RabbitListener(queues = RabbitmqConfig.QUEUE_NAME,containerFactory = "simpleRabbitListenerContainerFactory")
    public void rece_msg(String msg,Channel channel, Message message) throws IOException {
        log.info("当前线程:{},收到的简单消息:{}"+Thread.currentThread().getName()+msg);
        try {
            String show="";
            if(msg!=null && msg.length()>0){
                JSONObject JSONObj=JSONObject.parseObject(msg);
                AnalysisReceiveOrder485 analysisReceive=new AnalysisReceiveOrder485();
                QueueParam queueParam=new QueueParam();
                queueParam.setRecData(JSONObj.getString("recData"));
                queueParam.setDeviceType(JSONObj.getString("deviceType"));
                queueParam.setRegisterAddr(JSONObj.getString("registerAddr"));
                queueParam.setProjectID(JSONObj.getString("projectID"));
                queueParam.setCopyTime(JSONObj.getString("copyTime"));
                String deviceType=JSONObj.getString("deviceType");
                show=deviceType+",数据:"+JSONObj.getString("recData");
                log.info("从队列接受到的信息-->"+show);
                if(deviceType!=null && deviceType.equals("电表")){
                    analysisReceive.analysisMeterQueue(queueParam);
                }else if(deviceType.equals("冷量计")){
                    analysisReceive.analysisCloudQueue(queueParam);
                }
            }
            //告诉服务器收到这条消息 已经被我消费了 可以在队列删掉 这样以后就不会再发了 否则消息服务器以为这条消息没处理掉 重启应用后还会在发
            channel.basicAck(message.getMessageProperties().getDeliveryTag(), false);
        } catch (Exception e) {
//            e.printStackTrace();
             //丢弃这条消息
            channel.basicNack(message.getMessageProperties().getDeliveryTag(), false, false);
            log.info("消费队列信息异常");
        }
    }
}
