package com.mh.user.controller;

import com.alibaba.fastjson.JSONArray;
import com.mh.common.http.HttpResult;
import com.mh.user.entity.chart.ChartEntity;
import com.mh.user.entity.chart.GetChartParams;
import com.mh.user.service.chart.ChartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author ljf
 * @title ： 图表查询接口
 * @description ：
 * @updateTime 2020-07-17
 * @throws ：
 */
@RestController
@RequestMapping("/report")
public class ChartController {

    @Autowired
    private ChartService chartService;

    @PostMapping("/getFirstColChartsData")
    public HttpResult getFirstColChartsData(@RequestBody GetChartParams getChartParams) {
        System.out.println(getChartParams.toString());
        // 遍历数组参数
        StringBuilder chooseIndexIds = new StringBuilder();
        int b = 0;
        for (int a :
                getChartParams.getChooseIndexId()) {
            b = b + 1;
            if (b == 1) {
                chooseIndexIds = new StringBuilder(String.valueOf(a));
            } else {
                chooseIndexIds.append(",").append(a);
            }
        }
        System.out.println(chooseIndexIds);
        Map<String,Object> map = new HashMap<>();
        map.put("choose_index_ids", chooseIndexIds.toString());
        map.put("begin_time",getChartParams.getBeginTime());
        map.put("end_time",getChartParams.getEndTime());
        map.put("type",getChartParams.getType());
        map.put("chart_id",getChartParams.getChartId());
        List<ChartEntity> chartEntityList = chartService.queryChartData(map);
        System.out.println(JSONArray.toJSONString(chartEntityList));
        return HttpResult.ok("success",chartEntityList);
    }

}
