package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.DeviceInfoEntity;
import com.mh.user.model.ChillerModel;
import com.mh.user.model.DeviceModel;
import com.mh.user.service.DeviceInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("deviceInfo")
public class DeviceInfoController {

    @Autowired
    DeviceInfoService deviceInfoService;

    @SysLogger(value="设备信息",optDesc = "查询设备信息")
    @PostMapping("/query")
    public HttpResult queryMeterInfo(@RequestParam(value = "systemID") String systemID,
                                     @RequestParam(value = "projectID") String projectID,
                                     @RequestParam(value = "deviceType") String deviceType){

        List<DeviceInfoEntity> list=deviceInfoService.queryDeviceInfo(systemID,projectID,deviceType);
        return HttpResult.ok(list);
    }

    @SysLogger(value="设备信息",optDesc = "查询冷水机列表")
    @PostMapping("/list")
    public HttpResult selectDevices(@RequestParam(value = "systemID") String systemID,
                                     @RequestParam(value = "projectID") String projectID){
        List<DeviceModel> list=deviceInfoService.selectDevices(projectID);
        return HttpResult.ok(list);
    }

    @SysLogger(value="设备信息",optDesc = "查询多个冷水机相关信息")
    @PostMapping("/chillers")
    public HttpResult queryChiller(@RequestParam(value = "projectID") String projectID,
                                   @RequestParam(value = "deviceAddr") String deviceAddr){
        List<ChillerModel> list=deviceInfoService.queryChiller(projectID,deviceAddr);
        return HttpResult.ok(list);
    }

    @SysLogger(value="设备信息",optDesc = "查询单个冷水机相关信息")
    @PostMapping("/chiller")
    public HttpResult selectChiller(@RequestParam(value = "projectID") String projectID,
                                    @RequestParam(value = "deviceAddr") String deviceAddr){
        ChillerModel chillerModel=deviceInfoService.selectChiller(projectID,deviceAddr);
        return HttpResult.ok(chillerModel);
    }
}
