package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.DeviceInstallEntity;
import com.mh.user.entity.EnergyDataEntity;
import com.mh.user.entity.EnergyEntity;
import com.mh.user.model.EnergyModel;
import com.mh.user.service.EnergyDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("energyData")
public class EnergyDataController {

    @Autowired
    EnergyDataService energyDataService;

    @SysLogger(value="中央空调",optDesc = "按小时、天、月、年查询用量")
    @PostMapping("/query")
    public HttpResult queryEnergyData(@RequestBody EnergyModel energyModel){
        try{
            String projectID=energyModel.getProjectID();
            if(projectID!=null && projectID.length()>0){
                List<EnergyDataEntity> list=energyDataService.queryEnergyData(energyModel);
                int count=energyDataService.getEnergyDataCount(energyModel);
                return  HttpResult.ok(count,list);
            }else{
                return  HttpResult.error();
            }
        }catch (Exception e){
//            e.printStackTrace();
            return  HttpResult.error("查询出错!");
        }

    }

}
