package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.MeterInfoEntity;
import com.mh.user.service.MeterInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("meterInfo")
public class MeterInfoController {

    @Autowired
    MeterInfoService meterInfoService;

    @SysLogger(value="基表信息",optDesc = "查询基表信息")
    @PostMapping("/query")
    public HttpResult queryMeterInfo(@RequestParam(value = "systemID",required = false) String systemID,
                                     @RequestParam(value = "projectID",required = false) String projectID){

        List<MeterInfoEntity> list=meterInfoService.queryMeterInfo(systemID,projectID);
        return HttpResult.ok(list);
    }
}
