package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.config.RabbitmqConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("send")
@Slf4j
public class SendTest {

    @Autowired
    RabbitTemplate rabbitTemplate;

    @PostMapping(value="/test")
    public HttpResult sendMsgByTopics(){
        /**
         * 参数：
         * 1、交换机名称
         * 2、routingKey
         * 3、消息内容
         */
        for (int i=0;i<5;i++){
            String message = "恭喜您，注册成功！userId="+i;
            rabbitTemplate.convertAndSend(RabbitmqConfig.EXCHANGE_NAME,"topic.#.zjjd.#",message);
            log.info("SendMsg:" + message);
        }
        return HttpResult.ok();
    }

    @PostMapping(value="/op")
    public HttpResult operate(@RequestParam("opMsg") String opMsg){
        rabbitTemplate.convertAndSend(RabbitmqConfig.EXCHANGE_NAME,"topic.zjjd",opMsg);
        log.info("SendMsg:" + opMsg +" 到交换机"+RabbitmqConfig.EXCHANGE_NAME);
        return HttpResult.ok();
    }


    @PostMapping(value="/opt")
    public HttpResult test(@RequestParam("opMsg") String opMsg){
        rabbitTemplate.convertAndSend(RabbitmqConfig.EXCHANGE_NAME,"topic.zjjd",opMsg);
        log.info("SendMsg:" + opMsg +" 到交换机"+RabbitmqConfig.EXCHANGE_NAME);
        return HttpResult.ok();
    }
}
