package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.constants.Constant;
import com.mh.user.entity.ControlSetEntity;
import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.entity.DeviceInstallEntity;
import com.mh.user.model.SerialPortModel;
import com.mh.user.serialport.SerialPortSingle;
import com.mh.user.service.ControlSetService;
import com.mh.user.service.DeviceInstallService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("serial")
public class SerialPortController {

    @Autowired
    DeviceInstallService deviceInstallService;

    @Autowired
    ControlSetService controlSetService;

    //操作设备
    @PostMapping(value="/operate")
    public HttpResult operateDevice(@RequestBody List<SerialPortModel> params){
        try{
            SerialPortSingle serialPortSingle = new SerialPortSingle(); //发送接收类
            DeviceCodeParamEntity deviceCodeParam=new DeviceCodeParamEntity();//参数实体类

            Constant.WEB_FLAG=true; //单抄,暂时停止采集
            for (SerialPortModel serialPortModel :
                    params) {
                String deviceAddr=serialPortModel.getDeviceAddr();//设备通讯地址
                String deviceType=serialPortModel.getDeviceType();//设备类型
                String buildingId=serialPortModel.getBuildingId();//楼栋
                String param=serialPortModel.getParam();//操作参数
                DeviceInstallEntity deviceInstallEntity=deviceInstallService.selectDevice(deviceAddr,deviceType,buildingId);
                //发送指令实体类
                deviceCodeParam.setDeviceAddr(deviceAddr);
                deviceCodeParam.setDeviceType(deviceType);
                deviceCodeParam.setDataPort(deviceInstallEntity.getDataPort());
                deviceCodeParam.setBaudRate(deviceInstallEntity.getBaudRate());
                deviceCodeParam.setParity(deviceInstallEntity.getParity());
                deviceCodeParam.setDataValue(serialPortModel.getDataValue());//传入相关参数值
                deviceCodeParam.setProjectID(buildingId);
                String brand=deviceInstallEntity.getBrand();//品牌
                deviceCodeParam.setBrand(brand);
                ControlSetEntity controlData=new ControlSetEntity();

                //设置设备实体对象
                controlData.setBuildingId(deviceInstallEntity.getProjectID());

                if (deviceType==null || deviceType.equals("") || deviceType.equals("热泵")){
                    if (param==null || param.equals("") || param.equals("温度设定")){
                        //发送指令
                        deviceCodeParam.setRegisterAddr("0642"); //寄存器地址
                        deviceCodeParam.setFunCode("10");        //功能码写数据

                    }else if(param.equals("时段1")){
                        //发送指令
                        deviceCodeParam.setRegisterAddr("0656");    //寄存器地址
                        deviceCodeParam.setFunCode("10");           //功能码写数据
                        //保存数据
                        String time=serialPortModel.getDataValue();
                        if (time.length()==8){
                            String statTime=time.substring(0,2)+":"+time.substring(2,4);
                            String closeTime=time.substring(4,6)+":"+time.substring(6,8);
                        }

                    }else if(param.equals("时段2")){
                        //发送指令
                        deviceCodeParam.setRegisterAddr("065A");    //寄存器地址
                        deviceCodeParam.setFunCode("10");           //功能码写数据
                        //保存数据
                        String time=serialPortModel.getDataValue();
                        if (time.length()==8){
                            String statTime=time.substring(0,2)+":"+time.substring(2,4);
                            String closeTime=time.substring(4,6)+":"+time.substring(6,8);
                        }

                    }
                }else if (deviceType.equals("时控")){
                    deviceCodeParam.setRegisterAddr("0011"); //寄存器地址,L3路,L1(0009),L2(000D)
                    deviceCodeParam.setFunCode("10");        //功能码写数据
                    String time=serialPortModel.getDataValue();
                    if (time.length()==16){
                        //时段1
                        String statTime1=time.substring(0,2)+":"+time.substring(2,4);
                        String closeTime1=time.substring(4,6)+":"+time.substring(6,8);
                        //时段2
                        String statTime2=time.substring(8,10)+":"+time.substring(10,12);
                        String closeTime2=time.substring(12,14)+":"+time.substring(14,16);
                        controlData.setUseStartTime1(statTime1);
                        controlData.setUseCloseTime1(closeTime1);
                        controlData.setUseStartTime2(statTime2);
                        controlData.setUseCloseTime2(closeTime2);
                    }

                    controlSetService.saveControlSet(controlData); //保存设置内容
                }else if (deviceType.equals("水位开关")){
                    if (brand==null || brand.equals("") || brand.equals("中凯")){//品牌
                        deviceCodeParam.setFunCode("12");        //功能码写数据

                    }else if(brand.equals("远向")){
                        deviceCodeParam.setFunCode("06");        //功能码写数据
                    }else if(brand.equals("顶威")){
                        deviceCodeParam.setFunCode("0407");      //功能码写数据
                    }

                    deviceCodeParam.setDataValue(serialPortModel.getDataValue());

                    controlData.setLevelSet(serialPortModel.getDataValue());
                    controlSetService.saveControlSet(controlData);
                }

                serialPortSingle.serialPortSend(deviceCodeParam);//生成并发送指令
            }
            return HttpResult.ok();
        }catch(Exception e){
          e.printStackTrace();
            return HttpResult.error();
        }
    }

    //读数据
    @PostMapping(value="/read")
    public HttpResult readData(@RequestBody List<SerialPortModel> params){
        try{
            SerialPortSingle serialPortSingle = new SerialPortSingle();
            DeviceCodeParamEntity deviceCodeParam=new DeviceCodeParamEntity();

            for (SerialPortModel serialPortModel :
                    params) {
                String deviceAddr=serialPortModel.getDeviceAddr();
                String deviceType=serialPortModel.getDeviceType();
                String buildingId=serialPortModel.getBuildingId();
                String param=serialPortModel.getParam();
                DeviceInstallEntity deviceInstallEntity=deviceInstallService.selectDevice(deviceAddr,deviceType,buildingId);

                deviceCodeParam.setDeviceAddr(deviceAddr);
                deviceCodeParam.setDeviceType(deviceType);
                deviceCodeParam.setDataPort(deviceInstallEntity.getDataPort());
                deviceCodeParam.setBaudRate(deviceInstallEntity.getBaudRate());
                deviceCodeParam.setBrand(deviceInstallEntity.getBrand());

                if (deviceType.equals("热泵")){
                    if (param.equals("温度设定")){
                        deviceCodeParam.setRegisterAddr("0641");
                        deviceCodeParam.setFunCode("03");
                    }

                }else if (deviceType.equals("时控")){

                }else if (deviceType.equals("水位开关")){

                }else if (deviceType.equals("状态检测")){

                }

                Constant.WEB_FLAG=true; //单抄,暂时停止采集
                serialPortSingle.serialPortSend(deviceCodeParam);
            }
            return HttpResult.ok();
        }catch (Exception e){
            return HttpResult.error();
        }
    }

    @PostMapping(value="/pump")
    public HttpResult queryPumpSet(@RequestParam(value = "pumpId") String pumpId,
                                  @RequestParam(value = "buildingId") String buildingId){
        try{

            return HttpResult.ok();
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }

    @PostMapping(value="/control")
    public HttpResult queryControlSet(@RequestParam(value = "buildingId") String buildingId){
        try{
            ControlSetEntity list=controlSetService.queryControlSet(buildingId);
            return HttpResult.ok(list);
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }
}
