package com.mh.user.controller;

import com.mh.user.constants.Constant;
import com.mh.user.dynamic.datasource.DataSourceContextHolder;
import com.mh.user.dynamic.datasource.DataSourceObject;
import com.mh.user.entity.DBEntity;
import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.manage.QuartzManager;
import com.mh.user.service.SysUserService;
import com.mh.user.utils.AESUtil;
import com.mh.user.utils.AnalysisReceiveOrder485;
import com.mh.user.utils.ExchangeStringUtil;
import com.mh.user.utils.GetReadOrder485;
import org.quartz.SchedulerException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;

@RestController
public class TestController {

    @Autowired
    private SysUserService sysUserService;

    @Resource
    QuartzManager quartzManager;

    @RequestMapping("/hello")
    public String HelloWord() throws SchedulerException, InterruptedException {
        // 停止JobTest
        quartzManager.pauseAllJob();
        Constant.FLAG = true;
        Thread.sleep(2000);
        // 开始JobTest
//        quartzManager.resumeAllJob();
        Constant.FLAG = false;
        return "user hello word.";
    }

    @RequestMapping("/startHello")
    public String startHelloWord() throws SchedulerException, InterruptedException {
        // 停止JobTest
//        quartzManager.pauseAllJob();
//        Constant.FLAG = true;
//        Thread.sleep(2000);
        // 开始JobTest
        quartzManager.resumeAllJob();
        Thread.sleep(2000);
        Constant.FLAG = false;
        return "user hello word.";
    }

    @GetMapping("/test")
    public void testQuery(){
//        try{
//            DBEntity dbEntity = sysUserService.queryDBInfo("admin");
//            dbEntity.setDB_Pwd(AESUtil.AESdecrypt(dbEntity.getDB_Pwd()));
//            DataSourceObject dataSourceObject = new DataSourceObject();
//            String SourceName = "sqlServer-"+dbEntity.getDB_Names();
//            dataSourceObject.SwitchSQLServerDataSource(dbEntity,SourceName);
//            DataSourceContextHolder.setDBType(SourceName);
//        }catch (Exception e){
//           e.printStackTrace();
//        }

        AnalysisReceiveOrder485 analysis=new AnalysisReceiveOrder485();
        GetReadOrder485 getReadOrder485=new GetReadOrder485();
        DeviceCodeParamEntity deviceCodeParamEntity=new DeviceCodeParamEntity();
        deviceCodeParamEntity.setDeviceAddr("90");
        deviceCodeParamEntity.setDeviceType("冷量计");
        deviceCodeParamEntity.setRegisterAddr("34");
        deviceCodeParamEntity.setRegisterName("累积量");
        deviceCodeParamEntity.setGrade(1);
        deviceCodeParamEntity.setProjectID("3");
        analysis.analysisCloudOrder485("5A0304AEF600D911B6",deviceCodeParamEntity);

//        analysis.analysisWtMeterOrder485("FEFEFE6810398710810000008116901F00006502002C006502002C0000000000000000FF3416","","");
//        analysis.analysisPumpOrder485("0303020000C184","000B","","21");
//        analysis.analysisMeterOrder485("6810470010000068810643C3BA595C346716",deviceCodeParamEntity);
//        analysis.analysisRelayOrder485("220611000000013A220611000000023B220611000000033C220611000000043D220611000000053E220611000000063F22061100000007402206110000000841","0017","中凯");
//        analysis.analysisPressureOrder485("01030205157ADB","","澳升");

//        Date date2=new Date();
//        SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//        System.out.println("------时间--------"+sdf1.format(date2));
//        if (ExchangeStringUtil.isInDate(date2,"00:00:00","00:00:05")==true ||
//                ExchangeStringUtil.isInDate(date2,"00:00:20","00:00:25")==true ||
//                ExchangeStringUtil.isInDate(date2,"00:00:40","00:00:45")==true) {
//            System.out.println("------时间跳出--------"+sdf1.format(date2));
//
//        }

    }

}
