package com.mh.user.job;

import com.mh.user.entity.AddCronJobReq;
import com.mh.user.entity.ProjectInfoEntity;
import com.mh.user.manage.QuartzManager;
import com.mh.user.netty.EchoServer;
import com.mh.user.serialport.SerialPortListener;
import com.mh.user.serialport.SerialPortUtil;
import com.mh.user.service.ProjectInfoService;
import com.mh.user.utils.GetReadOrder485;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import lombok.extern.slf4j.Slf4j;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author ljf
 * @title ：
 * @description ： 自动执行采集程序,通过
 * @updateTime 2020-05-15
 * @throws ：
 */
@Component
public class CollectionLoopRunner implements ApplicationRunner {

	private static final Logger log = Logger.getLogger(CollectionLoopRunner.class);

	public static SerialPort serialPort = null;

	@Autowired
	ProjectInfoService projectInfoService;

	@Override
	public void run(ApplicationArguments args) throws Exception {
		GetReadOrder485 getReadOrder485=new GetReadOrder485();
		List<ProjectInfoEntity> projectInfoEntities = projectInfoService.queryProjectInfo("1");
		if (null != projectInfoEntities && !projectInfoEntities.isEmpty()) {
			for (ProjectInfoEntity projectInfoEntity : projectInfoEntities) {
				getReadOrder485.createOrderParam(projectInfoEntity.getId());    //生成采集参数,1新珠江（6000）,2广合科技（6001）,3广大科技（6002）,6珠江国际,7保利山庄,8东莞迎宾馆
			}
		}
		try{
			new EchoServer(6001).start();                // 调用服务器的start方法,网关作为客户端,6006新珠江,6001广合科技,6077广大科技 6028(6006)珠江国际,5000保利山庄,6004东莞迎宾馆
		}catch (Exception e){
			log.info("6001端口已占用！");
		}
	}

//	public void test() throws Exception {
//		System.out.println("测试定时采集开关");
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "2");
//		params.put("name", "test1");
//		//每 1 分钟 执行一次
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		addCronJobReq.setDate("0/10 * * * * ?");
////        addCronJobReq.setDate("0/5 * * * * ?");
//		addCronJobReq.setJobClass("JobTest1");
//		addCronJobReq.setJobGroupName("JobTestGroup1");
//		addCronJobReq.setJobName("Test1");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerTestGroup1");
//		addCronJobReq.setTriggerName("triggerTest1");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//
//	/**
//	 * 定时采集电表和冷量计
//	 *
//	 * @throws Exception
//	 */
//	public void collectionMeterAndCloud() throws Exception {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "6");
//		params.put("name", "cloud_meter");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每 15 分钟 执行一次
//		addCronJobReq.setDate("0 0/15 * * * ?");
//		//每 3 分钟 执行一次
////		addCronJobReq.setDate("35 0/2 * * * ?");
//		//每 2 分钟 执行一次
////		addCronJobReq.setDate("25 0/2 * * * ?");
//		//每 1 分钟 执行一次
////		addCronJobReq.setDate("0/10 * * * * ?");
////        addCronJobReq.setDate("0/5 * * * * ?");
//		addCronJobReq.setJobClass("JobCloudAndMeter");
//		addCronJobReq.setJobGroupName("JobCloudAndMeterGroup");
//		addCronJobReq.setJobName("CloudAndMeter");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerCloudAndMeterGroup");
//		addCronJobReq.setTriggerName("triggerCloudAndMeter");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//
//	/**
//	 * 定时采集冷量计
//	 *
//	 * @throws Exception
//	 */
//	public void collectionCloud() throws Exception {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "1");
//		params.put("name", "cloud");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每 2 分钟 执行一次
//		addCronJobReq.setDate("25 0/2 * * * ?");
////        addCronJobReq.setDate("0/5 * * * * ?");
//		addCronJobReq.setJobClass("JobCloud");
//		addCronJobReq.setJobGroupName("JobCloudGroup");
//		addCronJobReq.setJobName("Cloud");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerCloudGroup");
//		addCronJobReq.setTriggerName("triggerCloud");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//	/**
//	 * 定时采集电表
//	 *
//	 * @throws Exception
//	 */
//	public void collectionMeter() throws Exception {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "2");
//		params.put("name", "meter");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每 3 分钟 执行一次
//		addCronJobReq.setDate("35 0/2 * * * ?");
////        addCronJobReq.setDate("0/20 * * * * ?");
//		addCronJobReq.setJobClass("JobMeter");
//		addCronJobReq.setJobGroupName("JobMeterGroup");
//		addCronJobReq.setJobName("Meter");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerMeterGroup");
//		addCronJobReq.setTriggerName("triggerMeter");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//
//	/**
//	 * 定时采集DDC设备
//	 *
//	 * @throws Exception
//	 */
//	public void collectionDDC() throws Exception {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "3");
//		params.put("name", "ddc");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每 1分钟 执行一次
////        addCronJobReq.setDate("3,33 * * * * ?");
//		addCronJobReq.setDate("45 0/1 * * * ?");
//		addCronJobReq.setJobClass("JobDDC");
//		addCronJobReq.setJobGroupName("JobDDCGroup");
//		addCronJobReq.setJobName("DDC");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerDDCGroup");
//		addCronJobReq.setTriggerName("triggerDDC");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//
//	/**
//	 * 定时采集冷水机组设备
//	 *
//	 * @throws Exception
//	 */
//	public void collectionChillers() throws Exception {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "4");
//		params.put("name", "chillers");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每3分钟 执行一次
//		addCronJobReq.setDate("55 0/2 * * * ? ");
////        addCronJobReq.setDate("0/30 * * * * ?");
//		addCronJobReq.setJobClass("JobChillers");
//		addCronJobReq.setJobGroupName("JobChillersGroup");
//		addCronJobReq.setJobName("Chillers");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerChillersGroup");
//		addCronJobReq.setTriggerName("triggerChillers");
//		quartzManager.addCronJob(addCronJobReq);
//	}
//
//	/**
//	 * 4分钟，采集第二个冷水机组数据
//	 */
//	public void collectionChillers1() {
//		// 执行定义的定时采集程序
//		Map<String, String> params = new HashMap<>();
//		params.put("id", "5");
//		params.put("name", "chillers1");
//		AddCronJobReq addCronJobReq = new AddCronJobReq();
//		//每 4分钟 执行一次
//		addCronJobReq.setDate("0 0/5 * * * ? ");
////        addCronJobReq.setDate("0/30 * * * * ?");
//		addCronJobReq.setJobClass("JobChillers1");
//		addCronJobReq.setJobGroupName("JobChillersGroup1");
//		addCronJobReq.setJobName("Chillers1");
//		addCronJobReq.setParams(params);
//		addCronJobReq.setTriggerGroupName("triggerChillersGroup1");
//		addCronJobReq.setTriggerName("triggerChillers1");
//		try {
//			quartzManager.addCronJob(addCronJobReq);
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//	}
//
//	public void testSerialPort(){
//
//		String portname = "COM7";
//		//TestA();
//		//查看所有串口
//		SerialPortUtil serialPortUtil = SerialPortUtil.getSerialPortUtil();
//		ArrayList<String> port = serialPortUtil.findPort();
//		System.out.println("发现全部串口：" + port);
//
//		System.out.println("打开指定portname:" + portname);
//		//打开该对应portname名字的串口
//		CollectionLoopRunner.serialPort = serialPortUtil.openPort(portname, 2400, SerialPort.DATABITS_8, SerialPort.PARITY_EVEN, SerialPort.PARITY_ODD);
//
//		byte[] HEX = SerialPortListener.hexStr2Byte("FEFEFE6810398710810000000103901F007C16");
//		serialPortUtil.sendToPort(CollectionLoopRunner.serialPort, HEX);
//
//		//给对应的serialPort添加监听器
//		serialPortUtil.addListener(CollectionLoopRunner.serialPort, new SerialPortListener());
//
//	}
//
//	public void plcAnalytic() {
//		String portName = "COM1";
//		//查看所有串口
//		SerialPortUtil serialPortUtil = SerialPortUtil.getSerialPortUtil();
//		//打开该对应portName名字的串口
//		if (CollectionLoopRunner.serialPort == null) {
//			CollectionLoopRunner.serialPort = serialPortUtil.openPort(portName, 19200, SerialPort.DATABITS_8, SerialPort.PARITY_NONE, SerialPort.PARITY_ODD);
//			byte[] hex = SerialPortListener.hexStr2Byte("A55A230000000022".replaceAll("\\s*", ""));
//			serialPortUtil.sendToPort(CollectionLoopRunner.serialPort, hex);
//
//			//给对应的serialPort添加监听器-->设置串口的Listener
//			SerialPortUtil.setListenerToSerialPort(CollectionLoopRunner.serialPort, serialPortEvent -> {
//				if (serialPortEvent.getEventType() == SerialPortEvent.DATA_AVAILABLE) {
//					byte[] bytes = serialPortUtil.readFromPort(CollectionLoopRunner.serialPort);
//
//					String needData = SerialPortListener.printHexString(bytes);
//
//					//数据校验 校验数据长度、起始5A A5、数据sum位
////					if (PlcUtil.makeChecksum(needData)) {
////						//数据解析方法 此处编写你的解析方法，根据获取到的数据编写适合自己的方法
////					}
//				}
//			});
//		}
//	}

}
