package com.mh.user.job;

import com.mh.user.constants.Constant;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

/**
 *  :@DisallowConcurrentExecution : 此标记用在实现Job的类上面,意思是不允许并发执行.
 *  :注意org.quartz.threadPool.threadCount线程池中线程的数量至少要多个,否则@DisallowConcurrentExecution不生效
 *  :假如Job的设置时间间隔为3秒,但Job执行时间是5秒,设置@DisallowConcurrentExecution以后程序会等任务执行完毕以后再去执行,
 *  否则会在3秒时再启用新的线程执行
 */
@DisallowConcurrentExecution
@Slf4j
public class JobTest implements Job {
    @SneakyThrows
    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        for (int i = 0; i < 30; i++) {
            if (Constant.FLAG) {
                break;
            }
            Thread.sleep(1000);
            log.info("第" + i + "个，" +jobExecutionContext.getJobDetail()+"---------------------定时任务测试----------------------");
        }

    }
}
