package com.mh.user.mapper;

import com.mh.user.entity.DeviceInfoEntity;
import com.mh.user.mapper.provider.DeviceInfoProvider;
import com.mh.user.model.ChillerModel;
import com.mh.user.model.DeviceModel;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface DeviceInfoMapper {

    //查询仪表信息
    @SelectProvider(type = DeviceInfoProvider.class,method = "queryDeviceInfo")
    @Results(value = {
            @Result(property="id",column="id"),
            @Result(property="deviceName",column="deviceName"),
            @Result(property="deviceType",column="deviceType"),
            @Result(property="brand",column="brand"),
            @Result(property ="power",column ="power"),
            @Result(property ="madeTime",column ="madeTime"),
            @Result(property="flow",column="flow"),
            @Result(property="isFC",column="isFC"),
            @Result(property="motorBrand",column="motorBrand"),
            @Result(property="projectID",column="project_id"),
            @Result(property="systemID",column="system_id")
    })
    List<DeviceInfoEntity> queryDeviceInfo(@Param("systemID") String systemID,
                                           @Param("projectID") String projectID,
                                           @Param("deviceType") String deviceType);

    //查询冷水机设备列表
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName")
    })
    @Select("select * from  device_code  where  project_id=#{projectID}  and  device_type='冷水机'")
    List<DeviceModel> selectDevices(@Param("projectID") String projectID);


    //查询多个冷水机相关信息
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName"),
            @Result(column = "runState", property = "runState"),
            @Result(column = "setPoint", property = "setPoint"),
            @Result(column = "enterChw", property = "enterChw"),
            @Result(column = "leaveChw", property = "leaveChw"),
            @Result(column = "enterCow", property = "enterCow"),
            @Result(column = "leaveCow", property = "leaveCow"),
            @Result(column = "power", property = "power"),
            @Result(column = "ratedPower", property = "ratedPower"),
            @Result(column = "chillerAmps", property = "chillerAmps"),
            @Result(column = "refrigeration", property = "refrigeration"),
            @Result(column = "ratedRef", property = "ratedRef"),
            @Result(column = "chwFlow", property = "chwFlow"),
            @Result(column = "ApproachCow", property = "ApproachCow"),
            @Result(column = "ApproachChw", property = "ApproachChw"),
            @Result(column = "cop", property = "cop"),
            @Result(column = "ratedCop", property = "ratedCop"),
            @Result(column = "copyDate", property = "copyDate")
    })
    @Select("select * from  device_code  where project_id=#{projectID}  and  device_addr=#{deviceAddr} ")
    List<ChillerModel> queryChiller(@Param("projectID") String projectID, @Param("device_addr") String deviceAddr);

    //查询单个冷水机相关信息
    @Results({
            @Result(column = "device_addr",property = "deviceAddr" ),
            @Result(column = "device_name", property = "deviceName"),
            @Result(column = "runState", property = "runState"),
            @Result(column = "setPoint", property = "setPoint"),
            @Result(column = "enterChw", property = "enterChw"),
            @Result(column = "leaveChw", property = "leaveChw"),
            @Result(column = "enterCow", property = "enterCow"),
            @Result(column = "leaveCow", property = "leaveCow"),
            @Result(column = "power", property = "power"),
            @Result(column = "ratedPower", property = "ratedPower"),
            @Result(column = "chillerAmps", property = "chillerAmps"),
            @Result(column = "refrigeration", property = "refrigeration"),
            @Result(column = "ratedRef", property = "ratedRef"),
            @Result(column = "chwFlow", property = "chwFlow"),
            @Result(column = "ApproachCow", property = "ApproachCow"),
            @Result(column = "ApproachChw", property = "ApproachChw"),
            @Result(column = "cop", property = "cop"),
            @Result(column = "ratedCop", property = "ratedCop"),
            @Result(column = "copyDate", property = "copyDate")
    })
    @Select("select * from  chiller_data  where  project_id=#{projectID}  and  device_addr=#{deviceAddr} ")
    ChillerModel selectChiller(@Param("projectID") String projectID,@Param("device_addr") String deviceAddr);
}
