package com.mh.user.mapper;

import com.mh.user.entity.EnergyDataEntity;
import com.mh.user.mapper.provider.EnergyDataProvider;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface EnergyDataMapper {

    //按10分钟
    @SelectProvider(type = EnergyDataProvider.class,method = "queryEnergyDataMi")
    @Results(id="rs",value = {
            @Result(property="curDate",column="cur_date"),
            @Result(property="projectID",column="project_id"),
            @Result(property="projectName",column="project_name"),
            @Result(property="ambTemp",column="amb_Temp"),
            @Result(property ="humidity",column ="humidity"),
            @Result(property ="water",column ="water"),
            @Result(property="elect",column="elect"),
            @Result(property="cl",column="cl"),
            @Result(property="cop",column="cop")
    })
    List<EnergyDataEntity> queryEnergyDataMi(@Param("projectID") String projectID,
                                             @Param("curDate") String curDate,
                                             @Param("page") int page, @Param("limit") int limit);


    @SelectProvider(type = EnergyDataProvider.class,method = "getEnergyDataMiCount")
    int getEnergyDataMiCount(@Param("projectID") String projectID, @Param("curDate") String curDate);

    //按小时
    @SelectProvider(type = EnergyDataProvider.class,method = "queryEnergyDataHour")
    @ResultMap("rs")
    List<EnergyDataEntity> queryEnergyDataHour(@Param("projectID") String projectID,
                                             @Param("curDate") String curDate,
                                             @Param("page") int page, @Param("limit") int limit);

    @SelectProvider(type = EnergyDataProvider.class,method = "getEnergyDataHourCount")
    int getEnergyDataHourCount(@Param("projectID") String projectID, @Param("curDate") String curDate);

    //按天
    @SelectProvider(type = EnergyDataProvider.class,method = "queryEnergyDataDay")
    @ResultMap("rs")
    List<EnergyDataEntity> queryEnergyDataDay(@Param("projectID") String projectID,
                                              @Param("curDate") String curDate,
                                              @Param("queryType") int queryType,
                                              @Param("page") int page,
                                              @Param("limit") int limit);

    @SelectProvider(type = EnergyDataProvider.class,method = "getEnergyDataDayCount")
    int getEnergyDataDayCount(@Param("projectID") String projectID, @Param("curDate") String curDate, @Param("queryType") int queryType);

    //按月
    @SelectProvider(type = EnergyDataProvider.class,method = "queryEnergyDataMonth")
    @ResultMap("rs")
    List<EnergyDataEntity> queryEnergyDataMonth(@Param("projectID") String projectID,
                                                @Param("curDate") String curDate,
                                                @Param("queryType") int queryTyp,
                                                @Param("page") int page, @Param("limit") int limit);

    @SelectProvider(type = EnergyDataProvider.class,method = "getEnergyDataMonthCount")
    int getEnergyDataMonthCount(@Param("projectID") String projectID, @Param("curDate") String curDate, @Param("queryType") int queryType);

    //按年
    @SelectProvider(type = EnergyDataProvider.class,method = "queryEnergyDataYear")
    @ResultMap("rs")
    List<EnergyDataEntity> queryEnergyDataYear(@Param("projectID") String projectID,
                                               @Param("startDate") String startDate,
                                               @Param("endDate") String endDate,
                                               @Param("queryType") int queryType,
                                               @Param("page") int page, @Param("limit") int limit);

    @SelectProvider(type = EnergyDataProvider.class,method = "getEnergyDataYearCount")
    int getEnergyDataYearCount(@Param("projectID") String projectID,
                               @Param("startDate") String startDate,
                               @Param("endDate") String endDate,
                               @Param("queryType") int queryType);

}
