package com.mh.user.mapper;

import com.mh.user.mapper.provider.SysRoleProvider;
import com.mh.user.mapper.provider.SysUserProvider;
import com.mh.user.model.SysRole;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * author: ljf
 * desc: 系统角色Mapper
 */
@Mapper
public interface SysRoleMapper {

    //删除记录
    int deleteByPrimaryKey(@Param("id") Long id);

    //插入记录
    int insert(SysRole record);

    int insertSelective(SysRole record);

    SysRole selectByPrimaryKey(Long id);

    int updateByPrimaryKeySelective(SysRole record);

    int updateByPrimaryKey(SysRole record);

    List<SysRole> findPage();

	List<SysRole> findAll();

	List<SysRole> findPageByName(@Param(value = "roleName") String name);

	List<SysRole> findByName(@Param(value = "roleName") String name);

    @Results(id="rs",value = {
            @Result(property="id",column="id"),
            @Result(property="name",column="role_name"),
            @Result(property="createBy",column="create_by"),
            @Result(property="createTime",column="create_time"),
            @Result(property ="lastUpdateBy",column ="last_update_by"),
            @Result(property ="lastUpdateTime",column ="last_update_time"),
            @Result(property="delFlag",column="del_flag"),
            @Result(property="remarks",column="remarks")
    })
    @Select("select * from sys_role where  role_name=#{roleName}")
    SysRole findId(@Param(value = "roleName") String name);

    //查询所有角色
    @ResultMap("rs")
    @SelectProvider(type = SysRoleProvider.class,method = "queryRoles")
    List<SysRole> queryRoles(@Param("roleName") String roleName,@Param(value = "page") int page,@Param(value = "limit") int limit);

    //查询所有记录数
    @SelectProvider(type = SysRoleProvider.class,method = "getCount")
    int getCount(@Param("roleName") String roleName,@Param(value = "page") int page,@Param(value = "limit") int limit);

    //根据用户名查询角色编号
    @Select("select t1.id,t1.user_name,t2.role_id from sys_user t1 join sys_user_role t2 on t1.id=t2.user_id  where  t1.user_name=#{name} ")
    String findRoleID(@Param(value = "name") String name);

}
