package com.mh.user.mapper.chart;

import com.mh.user.entity.chart.BaseChartEntity;
import com.mh.user.entity.chart.Unit;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @author ljf
 * @title ： 表格mapper层
 * @description ：
 * @updateTime 2020-07-13
 * @throws ：
 */
@Component
@Mapper
public interface ChartMapper {

    // 执行存储过程，获取对应的数据
//    DECLARE	@return_value int
//
//    EXEC	@return_value = [dbo].[pro_chart]
//    @choose_index_ids = N'225',
//    @begin_time = N'2020-06-15 17:45:00.000',
//    @end_time = N'2020-06-15 18:45:00.000',
//    @type = NULL,
//    @chart_id = 1
//
//    SELECT	'Return Value' = @return_value
//
//    GO

    @Results({
            @Result(column = "chart_time", property = "chartTime"),
            @Result(column = "index_name", property = "indexName"),
            @Result(column = "index_type", property = "indexType"),
            @Result(column = "display_type", property = "displayType"),
            @Result(column = "index_id", property = "indexId"),
            @Result(column = "width", property = "width"),
            @Result(column = "chart_name", property = "chartName"),
            @Result(column = "time_name", property = "timeName"),
            @Result(column = "chart_id", property = "chartId"),
            @Result(column = "unit", property = "unit"),
            @Result(column = "data", property = "data")
    })
    @Select("exec pro_chart " +
            "#{map.choose_index_ids,mode=IN,jdbcType=VARCHAR}," +
            "#{map.begin_time,mode=IN,jdbcType=VARCHAR}," +
            "#{map.end_time,mode=IN,jdbcType=VARCHAR}," +
            "#{map.type,mode=IN,jdbcType=VARCHAR}," +
            "#{map.chart_id,mode=IN,jdbcType=INTEGER}")
    @Options(statementType = StatementType.CALLABLE)
    List<BaseChartEntity> callProChart(@Param("map") Map<?,?> map);

    // 查询单位接口
    @Results({
            @Result(column = "id", property = "id"),
            @Result(column = "unit_name", property = "unitName"),
            @Result(column = "unit", property = "unit"),
            @Result(column = "icon", property = "icon"),
            @Result(column = "grade", property = "grade"),
            @Result(column = "other_name", property = "otherName")
    })
    @Select("exec pro_unit " +
            "#{map.choose_index_ids,mode=IN,jdbcType=VARCHAR}")
    @Options(statementType = StatementType.CALLABLE)
    List<Unit> queryUnits(@Param("map") Map<?, ?> map);

}
