package com.mh.user.mapper.chillers;

import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;

import java.util.List;

/**
 * @author ljf
 * @title ：处理数据mapper层
 * @description ：
 * @updateTime 2020-07-28
 * @throws ：
 */
@Mapper
public interface DealDataMapper {

    //中央热水按日、月和年汇总水、电用量，计算单耗、平均用量
    @Select("exec pro_energy #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergy(@Param("curDate") String curDate);

    //中央空调按5分钟、小时、日、月和年汇电用量，冷量计算COP
    @Select("exec pro_energy_data #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergyData(@Param("curDate") String curDate);

    //
    @Select("exec pro_data_result #{curDate,jdbcType=VARCHAR,mode=IN},#{projectID,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proDataResult(@Param("curDate") String curDate,@Param("projectID") String projectID);

    @Select("exec pro_energy_day_sum #{curDate,jdbcType=VARCHAR,mode=IN},#{projectID,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergyDaySum(@Param("curDate") String curDate,@Param("projectID") String projectID);

    //汇总设备状态
    @Select("exec pro_device_state #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proDeviceState(@Param("curDate") String curDate);

    @Select("exec pro_analysis_month #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAnalysisMonth(@Param("curDate") String curDate);

    @Select("exec pro_analysis_year #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAnalysisYear(@Param("curDate") String curDate);

    @Select("exec pro_alarm_info_sum #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAlarmInfoSum(@Param("curDate") String curDate);

    ///////////////////////////////////////////////////////////
    @Select("exec pro_deal_data ")
    @Options(statementType = StatementType.CALLABLE)
    void dealData();

    @Delete("delete from chillers_data_history where convert(varchar(7),collection_time,23) = convert(varchar(7),dateadd(month,-3,getdate()),23)")
    void deleteChillersDataHistory();

    @Delete("delete from data_history where convert(varchar(7),cur_date,23) = convert(varchar(7),dateadd(month,-12,getdate()),23)")
    void deleteDataHistory();


    @Insert("insert into date_temperature(cur_date,amb_temp,humidity)values(#{curDate},#{ambTemp},#{humidity})")
    void dateTempHumidity(@Param("curDate") String curDate,
                          @Param("ambTemp") String ambTemp,
                          @Param("humidity") String humidity);

    @Update("update date_temperature set amb_temp=#{ambTemp},humidity=#{humidity} where convert(varchar(10),cur_date,121)=#{curDate} ")
    void updateDateTempHumidity(@Param("curDate") String curDate,
                                @Param("ambTemp") String ambTemp,
                                @Param("humidity") String humidity);

    @Select("select count(*) from date_temperature  where convert(varchar(10),cur_date,121)=#{curDate} ")
    int selectDateTempHumidity(@Param("curDate") String curDate);


    @Insert("insert into hour_temperature(cur_date,amb_temp,humidity)values(#{curDate},#{ambTemp},#{humidity})")
    void hourTempHumidity(@Param("curDate") String curDate,
                          @Param("ambTemp") String ambTemp,
                          @Param("humidity") String humidity);

    @Update("update hour_temperature set amb_temp=#{ambTemp},humidity=#{humidity} where convert(varchar(13),cur_date,121)=left(#{curDate},13)")
    void updateHourTempHumidity(@Param("curDate") String curDate,
                                @Param("ambTemp") String ambTemp,
                                @Param("humidity") String humidity);

    @Select("select count(*) from hour_temperature  where convert(varchar(13),cur_date,121)=left(#{curDate},13)")
    int selectHourTempHumidity(@Param("curDate") String curDate);

    //查找项目ID
    @Select("select id  from Project_Info  where  system_id=#{systemID}")
    List<String> queryProjectId(@Param("systemID") String systemID );

//    @Select("test(#{name,jdbcType=VARCHAR,mode=IN},#{gender,jdbcType=VARCHAR,mode=OUT})")
//    @Options(statementType = StatementType.CALLABLE)
//    void getGengder(People people);


}
