package com.mh.user.mapper.provider;

public class AlarmInfoProvider {

    public String queryAlarmInfo(String alarmTime,String deviceType,String buildingId,String dealState, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from Alarm_info  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        if (alarmTime!= null && !alarmTime.equals("")) {
            sql.append(" AND LEFT(alarm_time,10)=#{alarmTime} ");
        }
        if (dealState!= null && !dealState.equals("")) {
            sql.append(" AND deal_state=#{dealState} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
            sql.append(" ) T ");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getAlarmInfoCount(String alarmTime,String deviceType,String buildingId,String dealState, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  Alarm_info " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        if (alarmTime!= null && !alarmTime.equals("")) {
            sql.append(" AND LEFT(alarm_time,10)=#{alarmTime} ");
        }
        if (dealState!= null && !dealState.equals("")) {
            sql.append(" AND deal_state=#{dealState} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

        System.out.println(sql.toString());
        return sql.toString();
    }

}
