package com.mh.user.mapper.provider;

public class DataResultProvider {

    public String queryDataResult(String projectID,String startDate,String endDate,String deviceType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from data_result  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND deviceType = #{deviceType} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T   where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
            sql.append(" ) T ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getDataResultCount(String projectID,String startDate,String endDate,String deviceType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  data_result " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND deviceType = #{deviceType} ");
        }
        sql.append(" ) T  ");
//        System.out.println(sql.toString());
        return sql.toString();
    }
    //-----------------------------------------------------------------------------------------------
    //时间显示间隔为1分钟
    public String queryDataResultOneMi(String projectID, String startDate,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_one_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  where t2.rn>(#{page}-1)*#{limit} and t2.rn<=#{page}*#{limit}  order by t2.curDate desc");
        } else if (page == 0){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  order by t2.curDate desc");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String dataResultOneMiCount(String projectID, String startDate,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_one_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        sql.append(" group by curDate,projectID)t1) t2 ");
//        System.out.println(sql.toString());
        return sql.toString();
    }


    //时间显示间隔为5分钟
    public String queryDataResultFiveMi(String projectID,String startDate,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_five_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  where t2.rn>(#{page}-1)*#{limit} and t2.rn<=#{page}*#{limit}  order by t2.curDate desc");
        } else if (page == 0){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  order by t2.curDate desc");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String dataResultFiveMiCount(String projectID, String startDate,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_five_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        sql.append(" group by curDate,projectID)t1) t2 ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //时间显示间隔为15分钟
    public String queryDataResultFifteenMi(String projectID,String startDate,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_fifteen_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  where t2.rn>(#{page}-1)*#{limit} and t2.rn<=#{page}*#{limit}  order by t2.curDate desc");
        } else if (page == 0){
            sql.append(" group by curDate,projectID)t1) t2 join project_info t3  ON t2.projectID=t3.id  order by t2.curDate desc");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String dataResultFifteenMiCount(String projectID, String startDate,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by curDate) as rn from ( " +
                " select projectID,curDate,sum(cast(curValue as decimal(18,2))) as curValue from  data_result_five_mi " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        sql.append(" group by curDate,projectID)t1) t2 ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询冷水机参数历史数据情况
    public String queryDataResultChiller(String projectID,String deviceAddr,String registerName,String startDate,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by curDate) as rn from  data_result_chiller " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (deviceAddr!= null && !deviceAddr.equals("")) {
            sql.append(" AND deviceAddr=#{deviceAddr} ");
        }
        if (registerName!= null && !registerName.equals("")) {
            sql.append(" AND registerName=#{registerName} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.curDate desc");
        } else if (page == 0){
            sql.append(" )T order by T.curDate desc");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String dataResultChillerCount(String projectID,String deviceAddr,String registerName,String startDate,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by curDate) as rn from  data_result_chiller " +
                " where 1=1 ");
        if (projectID!= null && !projectID.equals("")) {
            sql.append(" AND projectID=#{projectID} ");
        }
        if (deviceAddr!= null && !deviceAddr.equals("")) {
            sql.append(" AND deviceAddr=#{deviceAddr} ");
        }
        if (registerName!= null && !registerName.equals("")) {
            sql.append(" AND registerName=#{registerName} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND curDate>=#{startDate} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND curDate<=#{curDate} ");
        }
        sql.append(" )T order by T.curDate desc");
//        System.out.println(sql.toString());
        return sql.toString();
    }
}
