package com.mh.user.mapper.provider;

public class DeviceInstallProvider {

    public String queryDevice(String buildingId,String deviceType,String startDate,String endDate,String isUse,String isFault, int page, int limit){
        StringBuffer sql = new StringBuffer("");

        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from device_install  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        if (startDate != null && endDate != null) {
            sql.append(" AND CONVERT(varchar(10),install_date,121)>=#{startDate} and CONVERT(varchar(10),install_date,121)<=#{endDate} ");
        }
//        else if (startDate == null || endDate == null){
//            sql.append(" AND CONVERT(varchar(10),install_date,121)>=GETDATE()-6 and CONVERT(varchar(10),install_date,121)<=GETDATE() ");
//        }
        if (isUse != null && !isUse.equals("")){
            sql.append(" AND is_use = #{isUse} ");
        }
        if (isFault != null && !isFault.equals("")){
            sql.append(" AND is_fault = #{isFault} ");
        }
        if ((page != 0) && (limit != 0)){
                sql.append(" ) T  join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
                sql.append(" ) T ");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }

    public String getCount(String buildingId,String deviceType,String startDate,String endDate,String isUse,String isFault, int page, int limit){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from device_install  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        if (startDate != null && endDate != null) {
            sql.append(" AND CONVERT(varchar(10),install_date,121)>=#{startDate} and CONVERT(varchar(10),install_date,121)<=#{endDate} ");
        }
//        else if (startDate == null || endDate == null){
//            sql.append(" AND CONVERT(varchar(10),install_date,121)>=GETDATE()-6 and CONVERT(varchar(10),install_date,121)<=GETDATE() ");
//        }
        if (isUse != null && !isUse.equals("")){
            sql.append(" AND is_use = #{isUse} ");
        }
        if (isFault != null && !isFault.equals("")){
            sql.append(" AND is_fault = #{isFault} ");
        }

        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

        System.out.println(sql.toString());
        return sql.toString();
    }

    public String getIsOnlineCount(String isOnline,String deviceType){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from device_install " +
                " where 1=1 ");
        if (isOnline != null && !isOnline.equals("")){
            sql.append(" AND is_online = #{isOnline} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }
}
