package com.mh.user.mapper.provider;

public class EnergyDataProvider {

    //按十分钟
    public String queryEnergyDataMi(String projectID,String curDate,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_mi  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if(projectID.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataMiCount(String projectID,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_mi  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if(projectID.equals("所有")){
            sql.append(" )T ");
        }else{
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按小时
    public String queryEnergyDataHour(String projectID,String curDate,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_hour  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if(projectID.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121) where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121) order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按小时记录数
    public String getEnergyDataHourCount(String projectID,String curDate){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_hour  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if(projectID.equals("所有")){
            sql.append(" )T ");
        }else{
            sql.append(" )T join project_info T1  ON T.project_id=T1.id  join hour_temperature t2  on LEFT(T.cur_date,13)=CONVERT(VARCHAR(13),t2.cur_date,121)");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }

    //按天
    public String queryEnergyDataDay(String projectID,String curDate,int queryType,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_day  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType==0){
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }else{
                sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
            }
        }
        if(projectID.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T order by T.cur_date  ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataDayCount(String projectID,String curDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_day  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if (queryType==0){
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }else{
                sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
            }
        }
        if(projectID.equals("所有")){
            sql.append(" )T ");
        }else{
            sql.append(" )T join project_info T1  ON T.project_id=T1.id  join date_temperature t2  on LEFT(T.cur_date,10)=CONVERT(VARCHAR(10),t2.cur_date,121) ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按月
    public String queryEnergyDataMonth(String projectID,String curDate,int queryType,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_month  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if(queryType==0){
                sql.append(" AND LEFT(cur_date,4)=#{curDate} ");
            }else {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }
        }
        if(projectID.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T order by T.cur_date  ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataMonthCount(String projectID,String curDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_month  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if (curDate != null && !curDate.equals("")) {
            if(queryType==0){
                sql.append(" AND LEFT(cur_date,4)=#{curDate} ");
            }else {
                sql.append(" AND LEFT(cur_date,7)=#{curDate} ");
            }
        }
        if(projectID.equals("所有")){
            sql.append(" )T ");
        }else{
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String queryEnergyDataYear(String projectID,String startDate,String endDate,int queryType,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_year  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if(projectID.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0){
                sql.append(" )T  order by T.cur_date  ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0){
                sql.append(" )T join project_info T1  ON T.project_id=T1.id  order by T.cur_date  ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //记录数
    public String getEnergyDataYearCount(String projectID,String startDate,String endDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_data_year  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }else{
            sql.append(" AND project_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if(projectID.equals("所有")){
            sql.append(" )T ");
        }else{
            sql.append(" )T join project_info T1  ON T.project_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }
}
