package com.mh.user.mapper.provider;

public class EnergyProvider {

    //小时
    public String queryEnergyHour(String projectID,String buildingId,String startDate,String endDate,int queryType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_hour  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)=#{startDate} ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T  order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join building T1  ON T.building_id=T1.id  order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按天
    public String queryEnergyDay(String projectID,String buildingId,String startDate,String endDate,int queryType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_day  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)=LEFT(#{startDate},10) ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T  order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join building T1  ON T.building_id=T1.id join project_info T2  ON T.project_id=T2.id where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join building T1  ON T.building_id=T1.id join project_info T2  ON T.project_id=T2.id order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按月
    public String queryEnergyMonth(String projectID,String buildingId,String startDate,String endDate,int queryType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_Month  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,7)>=LEFT(#{startDate},7) ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,7)<=LEFT(#{endDate},7) ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,7)=LEFT(#{startDate},7) ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T  order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date ");
            } else if (page == 0){
                sql.append(" )T join building T1  ON T.building_id=T1.id  order by T.cur_date ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按年
    public String queryEnergyYear(String projectID,String buildingId,String startDate,String endDate,int queryType, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_year  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}  order by T.cur_date  ");
            } else if (page == 0){
                sql.append(" )T  order by T.cur_date ");
            }
        }else{
            if ((page != 0) && (limit != 0)){
                sql.append(" )T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date");
            } else if (page == 0){
                sql.append(" )T join building T1  ON T.building_id=T1.id  order by T.cur_date");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    //按小时
    public String getEnergyHourCount(String projectID,String buildingId,String startDate,String endDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_day  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,13)=#{startDate} ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            sql.append(" ) T  ");
        }else{
            sql.append(" ) T join building T1  ON T.building_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按天
    public String getEnergyDayCount(String projectID,String buildingId,String startDate,String endDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_day  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)>=#{startDate} ");
            }
            if (endDate != null && !endDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,10)=LEFT(#{startDate},10) ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            sql.append(" ) T  ");
        }else{
            sql.append(" ) T join building T1  ON T.building_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按月
    public String getEnergyMonthCount(String projectID,String buildingId,String startDate,String endDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_month  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && startDate != null) {
                sql.append(" AND LEFT(cur_date,7)>=#{startDate} ");
            }
            if (endDate != null && endDate != null) {
                sql.append(" AND LEFT(cur_date,7)<=#{endDate} ");
            }
        }else{
            if (startDate != null && !startDate.equals("")) {
                sql.append(" AND LEFT(cur_date,7)=LEFT(#{startDate},7) ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            sql.append(" ) T  ");
        }else{
            sql.append(" ) T join building T1  ON T.building_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //按年
    public String getEnergyYearCount(String projectID,String buildingId,String startDate,String endDate,int queryType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_year  " +
                " where 1=1 ");
        if (projectID != null && !projectID.equals("")){
            sql.append(" AND project_id = #{projectID} ");
        }
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if(queryType==0){
            if (startDate != null && startDate != null) {
                sql.append(" AND LEFT(cur_date,4)>=#{startDate} ");
            }
            if (endDate != null && endDate != null) {
                sql.append(" AND LEFT(cur_date,4)<=#{endDate} ");
            }
        }else{
            if (startDate != null && startDate != null) {
                sql.append(" AND LEFT(cur_date,4)=#{startDate} ");
            }
        }
        if (buildingId != null && !buildingId.equals("") && buildingId.equals("所有")){
            sql.append(" ) T  ");
        }else{
            sql.append(" ) T join building T1  ON T.building_id=T1.id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询每天的用量
    public String queryDayEnergy(String buildingId,String startDate,String endDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");

        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_day  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if (startDate != null && !startDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)>=#{startDate} ");
        }
        if (endDate != null && !endDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)<=#{endDate} ");
        }
        if (buildingId.equals("所有")){
            if ((page != 0) && (limit != 0)){
                sql.append(" ) T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
            } else if (page == 0){
                sql.append(" ) T ");
            }
        }else {
            if ((page != 0) && (limit != 0)){
                sql.append(" ) T join building T1  ON T.building_id=T1.id where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
            } else if (page == 0){
                sql.append(" ) T ");
            }
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询每天的用量
    public String getDayEnergyCount(String buildingId,String startDate,String endDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select  count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from energy_Month  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }else{
            sql.append(" AND building_id <>'所有' ");
        }
        if (startDate != null && !startDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)>=#{startDate} ");
        }
        if (endDate != null && !endDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)<=#{endDate} ");
        }
        if (buildingId.equals("所有")){
            sql.append(" ) T");
        }else {
            sql.append(" ) T  join building T1  ON T.building_id=T1.id ");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }
}
