package com.mh.user.serialport;

import com.mh.user.constants.Constant;
import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.service.DeviceCodeParamService;
import com.mh.user.utils.AnalysisReceiveOrder485;
import com.mh.user.utils.SendOrderUtils;
import com.mh.user.utils.SpringBeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;
//import purejavacomm.SerialPort;
import gnu.io.SerialPort;
import java.nio.ByteBuffer;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;

/**
 * @author nxr
 * @title ：
 * @description ： 串口发送和接收处理,操作类
 * @updateTime 2022-08-10
 * @throws ：
 */
//@Slf4j
public class SerialPortSingle {

    public  SerialPort serialPort = null;
    private  String receiveStr = null;
    private  int baudrate=9600;
    private static final Logger log = Logger.getLogger(SerialPortSingle.class);

    // 调用service
    ApplicationContext context = SpringBeanUtil.getApplicationContext();
    DeviceCodeParamService deviceCodeParamService = context.getBean(DeviceCodeParamService.class);
    AnalysisReceiveOrder485 analysisReceiveOrder485 = new AnalysisReceiveOrder485();

    public String serialPortSend(DeviceCodeParamEntity deviceCodeParamEntity){

        //查看所有串口
        SerialPortUtil serialPortUtil = SerialPortUtil.getSerialPortUtil();
        ArrayList<String> port = serialPortUtil.findPort();

//        SerialTool serialPortUtil = SerialTool.getSerialPortUtil();
//        ArrayList<String> port = serialPortUtil.findPort();

        System.out.println("发现全部串口：" + port);
        String comName=deviceCodeParamEntity.getDataPort().toUpperCase();
        if (port.contains(comName)){
            try{
                baudrate=deviceCodeParamEntity.getBaudRate();
                serialPort = serialPortUtil.openPort(comName, baudrate, SerialPort.DATABITS_8, SerialPort.PARITY_EVEN, SerialPort.PARITY_ODD);
                //向串口发送指令
                SendOrderUtils.sendSerialPort(deviceCodeParamEntity, serialPort);
                log.info("单抄向串口"+serialPort+"发送指令！");
//                try{
//                    Thread.sleep(1500);
//                }catch (Exception e){
//                    e.printStackTrace();
//                }
//
//                //对返回数据进行相关解析处理
//                receiveStr=null;
//                byte[] bytes = serialPortUtil.readFromPort(serialPort); //读取串口数据
//                try {
//                    String byteStr = new String(bytes, 0, bytes.length).trim();
//                } catch (NullPointerException e) {
//                    serialPortUtil.closePort(serialPort);
//                    try{
//                        Thread.sleep(2000);
//                    }catch (Exception t){
//                        t.printStackTrace();
//                    }
//                    log.info("单抄串口"+serialPort+"没有数据返回！");
//                }
//                System.out.println("===========start===========");
//                receiveStr = receiveStr + printHexString(bytes);
//                //去掉空格和null
//                receiveStr = receiveStr.replace("null", "");
//                receiveStr = receiveStr.replace(" ", "");
//                log.info("串口"+serialPort+"接收数据：" + receiveStr + "，大小： " + receiveStr.length());
                System.out.println("============end============");
                //模拟返回数据
//                receiveStr="021006420001a166";//温度设定
//                receiveStr="0210065600042161";//热泵设定时段
                receiveStr="220712000000013c";//水位设定
                //返回值全部变成大写
                String receiveData = receiveStr.toUpperCase();
                //截取去掉FE
                String dataStr = receiveData.replace("FE", "");
                String deviceType=deviceCodeParamEntity.getDeviceType();
                String deviceAddr=deviceCodeParamEntity.getDeviceAddr();
                String brand=deviceCodeParamEntity.getBrand();
                String buildingId=deviceCodeParamEntity.getProjectID();
                try{
                    if ((dataStr.length() == 70 || dataStr.length() == 44)  && deviceType.equals("水表")) {
                        analysisReceiveOrder485.analysisWtMeterOrder485(dataStr,deviceAddr,brand,buildingId);
                    } else if ((dataStr.length() == 36 || dataStr.length() == 44 || dataStr.length()==40 || dataStr.length()==50) &&  deviceType.equals("电表")) {
                        analysisReceiveOrder485.analysisMeterOrder485(dataStr,deviceCodeParamEntity);
                    }
                }catch (Exception e){
//              e.printStackTrace();
                    log.error(deviceCodeParamEntity.getDeviceType()+"单抄保存数据库失败！"+0);
                    serialPortUtil.closePort(serialPort);
                }

                serialPortUtil.closePort(serialPort);
                Constant.WEB_FLAG=false; //没有指令下发定时采集生效
                System.out.println("关闭"+serialPort);
                try{
                    Thread.sleep(500);
                }catch (Exception e){
                    e.printStackTrace();
                }
                return "";
            }catch (Exception e){
                e.printStackTrace();
            }

        }else {
//            System.out.println("串口："+comName+"不存在!" );
            log.info("串口："+comName+"不存在!");
        }
        return "";
    }
    /**
     * 字节数组转16进制字符串
     * @param b 字节数组
     * @return 16进制字符串
     */
    public static String printHexString(byte[] b) {
        StringBuilder sbf = new StringBuilder();
        for (byte value : b) {
            String hex = Integer.toHexString(value & 0xFF);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }
            sbf.append(hex.toUpperCase()).append(" ");
        }
        return sbf.toString().trim();
    }

    /**
     * 十六进制字符串转byte[]
     * @param hex 十六进制字符串
     * @return byte[]
     */
    public static byte[] hexStr2Byte(String hex) {
        if (hex == null) {
            return new byte[] {};
        }

        // 奇数位补0
        if (hex.length() % 2 != 0) {
            hex = "0" + hex;
        }

        int length = hex.length();
        ByteBuffer buffer = ByteBuffer.allocate(length / 2);
        for (int i = 0; i < length; i++) {
            String hexStr = hex.charAt(i) + "";
            i++;
            hexStr += hex.charAt(i);
            byte b = (byte) Integer.parseInt(hexStr, 16);
            buffer.put(b);
        }
        return buffer.array();
    }
    /**
     * 16进制转换成为string类型字符串
     * @param s 待转换字符串
     */
    public static String hexStringToString(String s) {
        if (s == null || "".equals(s)) {
            return null;
        }
        s = s.replace(" ", "");
        byte[] baKeyword = new byte[s.length() / 2];
        for (int i = 0; i < baKeyword.length; i++) {
            try {
                baKeyword[i] = (byte) (0xff & Integer.parseInt(s.substring(i * 2, i * 2 + 2), 16));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
            s = new String(baKeyword, StandardCharsets.UTF_8);
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return s;
    }
}
