package com.mh.user.service;

import com.mh.user.entity.BuildingEntity;
import com.mh.user.entity.DeviceInstallEntity;
import com.mh.user.entity.DeviceInstallTempEntity;
import com.mh.user.entity.UploadDeviceInstallEntity;
import com.mh.user.mapper.provider.DeviceInstallProvider;
import com.mh.user.model.DeviceModel;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;

import java.util.Date;
import java.util.List;

public interface DeviceInstallService {

    /**
     * 设备管理模块
     * 保存设备信息
     *
     * @param deviceInstallEntity
     */
    int saveDevice(DeviceInstallEntity deviceInstallEntity);

    /**
     * 设备管理模块
     * 保存设备信息
     *
     * @param deviceInstallEntity
     */
    int updateDevice(DeviceInstallEntity deviceInstallEntity);

    //按id更新水电表读数和采集日期
    void updateLastValue(Long id, double lastValue, Date lastDate);
    /**
     * 设备管理模块
     * 查询设备资料
     *
     * @param page
     * @param limit
     * @return
     */
    List<DeviceInstallEntity> getAllDevice(int page, int limit);

    //查询有多个采集参数的设备
    List<DeviceInstallEntity> selectDeviceParams(String ProjectID);

    //查询有多个采集参数的设备
    List<DeviceInstallEntity> selectDeviceParams2();

    // 查询所有启用的设备
    int getAllCount();
    /**
     * 设备管理模块
     * 按条件查询设备资料
     *
     * @param buildingId
     * @param startDate
     * @param startDate
     * @param page
     * @param limit
     * @return
     */
    List<DeviceInstallEntity> queryDevice(String buildingId,String deviceType, String startDate, String endDate, String isUse, String isFault, int page, int limit);

    /**
     * 设备管理模块：
     * 获取设备查询的总条数
     *
     * @return
     */
    int getCount(String buildingId,String deviceType, String startDate, String endDate, String isUse, String isFault, int page, int limit);

    //查询设备在线情况
    int getIsOnlineCount(String isOnline,String deviceType);

    //根据通讯地址和设备类型查询对应的设备信息
    DeviceInstallEntity selectDevice(String deviceAddr,String deviceType,String buildingId);
    /**
     * 设备管理模块
     * 根据通讯地址删除设备信息
     *
     * @param records
     */
    int deleteDevice(List<DeviceInstallEntity> records);
    /**
     * 设备管理模块
     * 根据通讯地址删除设备信息
     *
     * @param id
     */
    int deleteDevice(String id);

    // Excel导入相关函数
    // 删除临时表
    void deleteDevice_install_temp();

    // 插入临时表
    void insertDevice_install_temp(UploadDeviceInstallEntity uploadDeviceInstallEntity);

    // 查询Excel导入的数据
    List<DeviceInstallTempEntity> queryExcelDevices();

    // 查询Excel导入的数据的记录数
    int queryExcelDevicesCount();

    // 在导入中的数据有重复
    void updateDevice_install_temp__multiple();

    //从临时表查询插入
    void insertFromDevice_install_temp();

    //修改启动状态
    void updateDeviceIsUse(String isUse, String deviceAddr);

}
