package com.mh.user.service;

import com.mh.user.entity.EnergyEntity;
import com.mh.user.mapper.provider.EnergyProvider;
import com.mh.user.model.EnergyParam;
import org.apache.ibatis.annotations.*;

import java.util.List;

public interface EnergyService {

    /**
     * 生产信息
     * 保存
     * @param energyEntity
     */
    void saveEnergy(EnergyEntity energyEntity,int type);

    /**
     * 生产信息
     * 修改
     * @param energyEntity
     */
    void updateEnergy(EnergyEntity energyEntity,int type);

    /**
     * 生产信息
     * 根据时间日期和楼栋编号删除记录
     * @param curDate
     * @param buildingId
     */
    void deleteEnergy(String curDate,String buildingId,int type);


    /**
     * 生产信息
     * 查询
     * @param （type 1按天，2按月，3按年）
     * @return
     */
    List<EnergyEntity> queryEnergy(EnergyParam energyParam);

    /**
     * 生产信息
     * 查询记录数
     * @return
     */
    int getEnergyCount(EnergyParam energyParam);

    /**
     * 生产信息
     * 查询
     * @param curDate
     * @param type (1按天，2按月，3按年)
     * @return
     */
    List<EnergyEntity> queryEnergyGroup(String curDate, int type);

    //查询每天的用量
    List<EnergyEntity> queryDayEnergy(String buildingId, String startDate, String endDate, int page, int limit);

    int getDayEnergyCount(String buildingId, String startDate, String endDate, int page, int limit);

}
