package com.mh.user.service.chart.impl;

import com.alibaba.fastjson.JSONArray;
import com.mh.user.entity.chart.*;
import com.mh.user.mapper.chart.ChartMapper;
import com.mh.user.service.chart.ChartService;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-07-13
 * @throws ：
 */
@Service
public class ChartServiceImpl implements ChartService {

  private final ChartMapper chartMapper;

  public ChartServiceImpl(ChartMapper chartMapper) {
    this.chartMapper = chartMapper;
  }

  @Override
  public List<BaseChartEntity> callProChart(Map<?, ?> map) {
    return chartMapper.callProChart(map);
  }

  @Override
  public List<ChartEntity> queryChartData(Map<?, ?> map) {
    List<BaseChartEntity> baseChartEntityList = chartMapper.callProChart(map);
    int listSize = baseChartEntityList.size();
    // 判断是否有数据
    if (listSize != 0) {
      // 获取表名
      Title title = new Title(false, baseChartEntityList.get(0).getChartName());

      // 获取右侧单位显示
      List<Unit> units = chartMapper.queryUnits(map);
      boolean[] states = new boolean[11];
      String[] titles = new String[11];
      String[] icons = new String[11];
      String[] names = new String[11];
      String[] yAxisNames = new String[11];
      int size = 0;
      String title1 = "";
      for (int i = 0; i < units.size(); i++) {
        if (size - 1 >= 0) {
          title1 = titles[size - 1];
        }
        System.out.println(title1);
        if (title1.equalsIgnoreCase(units.get(i).getUnitName())) {
        } else {
          states[size] = Boolean.parseBoolean(units.get(i).getGrade());
          titles[size] = units.get(i).getUnitName();
          icons[size] = units.get(i).getIcon();
          // 查询指标对应c的单位名称
          names[size] = units.get(i).getIndexName();
          // 对应指标名称
          yAxisNames[size] = units.get(i).getOtherName();
          size = size + 1;
        }
      }

      // 获取Feature，图表显示的单位
      Feature feature = new Feature(states, titles, icons, names, yAxisNames);

      //获取不重复值，并保证元素添加的有序性，使用LinkedHashSet
      Set<Object> dataSet = new LinkedHashSet<>();            // 指标名称
      Set<Object> indexIdSet = new LinkedHashSet<>();         // 指标ID
      Set<Object> xAxisSet = new LinkedHashSet<>();           // 指标查询时间
      Set<Object> displayType = new LinkedHashSet<>();        // 指标显示类型
      for (BaseChartEntity baseChartEntity : baseChartEntityList) {
        dataSet.add(baseChartEntity.getIndexName());
        indexIdSet.add(baseChartEntity.getIndexId());
        xAxisSet.add(baseChartEntity.getChartTime());
        displayType.add(baseChartEntity.getDisplayType());
      }
      String[] indexNames = new String[dataSet.size()];
      int i = 0;
      for (Object object :
        dataSet) {
        indexNames[i] = (String) object;
        i++;
      }
      int width = baseChartEntityList.get(0).getWidth();
      int[] indexId = new int[indexIdSet.size()];
      i = 0;
      for (Object object :
        indexIdSet) {
        indexId[i] = (int) object;
        i++;
      }
      Legend legend = new Legend(indexNames, width, indexId);

      // 时间
      // 获取id值第一种方式
//            int endIndex = listSize / indexId.length;
//            String[] dates = new String[endIndex];
//            for (int j = 0; j < endIndex; j++) {
//                dates[j] = baseChartEntityList.get(j).getChartTime();
//            }

      String[] xAxis = new String[xAxisSet.size()];
      i = 0;
      for (Object object :
        xAxisSet) {
        xAxis[i] = (String) object;
        i++;
      }
      XAxis xAxis1 = new XAxis(xAxis);

      List<YAxis> yAxisList = new ArrayList<>();
      boolean show = true;
      for (int j = 0; j < dataSet.size(); j++) {
        if (j >= 2) {
          show = false;
        }
        yAxisList.add(new YAxis("value",
          indexNames[j],
          new SplitLine(false),
          new AxisLine(false, new LineStyle("#FFF")),
          show));
      }

      // 指标显示类型
//            String[] displayTypes = new String[displayType.size()];
//            i = 0;
//            for (Object object :
//                    displayType) {
//                displayTypes[i] = (String)object;
//                i++;
//            }
      List<Series> seriesList = new ArrayList<>();
      // 循环赋值
      int endIndex = listSize / indexId.length;
      for (int j = 0; j < dataSet.size(); j++) {
        // 遍历赋显示值
        Double[] doubles = new Double[endIndex];
        int a = 0;
        for (int k = j * endIndex; k < (j + 1) * endIndex; k++) {
          doubles[a] = baseChartEntityList.get(k).getData();
          a++;
        }
        // 显示指标类型
        seriesList.add(new Series(indexNames[j],
          baseChartEntityList.get(j * endIndex).getDisplayType(),
          j,
          doubles));
      }
      ChartEntity chartEntity = new ChartEntity(title, feature, legend, xAxis1, yAxisList, seriesList);
      List<ChartEntity> chartEntities = new ArrayList<>();
      chartEntities.add(chartEntity);
      return chartEntities;

    } else {
      return null;
    }
  }

  @Override
  public List<Unit> queryUnits(Map<?, ?> map) {
    return chartMapper.queryUnits(map);
  }
}
