package com.mh.user.service.chillers;

import com.mh.user.entity.ChillersEntity;
import com.mh.user.entity.HostValue;
import com.mh.user.entity.TableDataEntity;
import com.mh.user.entity.TableInfoEntity;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ： 冷水机组服务接口
 * @updateTime 2020-05-20
 * @throws ：
 */
public interface ChillersService {

    // 获取进出水温度
    List<HostValue> queryTempValue(String deviceType);

    // 查询正在运行的冷水机组
    List<ChillersEntity> getRunningChillers();

    // 查询已停止的冷水机组
    List<ChillersEntity> getStopChillers();

    // 根据启用状态，查询冷水机组全部设备信息
    List<ChillersEntity> queryChillersByOther(int grade, String ddcAddr);

    // 往数据库插入冷水机组历史流水表，返回插入后的自增id
    int insertChillersHistory(ChillersEntity chillersEntity);

    // 更新基表管理信息中对应的数据
    void updateChillerRegisterAddr(ChillersEntity chillersEntity);

    // 插入或者更新实时表
    void updateDataNow(ChillersEntity chillersEntity);

    // 批量更新历史数据
    int batchUpdateRegisterAddr(List<ChillersEntity> chillersEntityLists);

    List<TableDataEntity> queryTopData(String deviceName, int grade);

    List<TableInfoEntity> queryLeftAndRightData(String deviceName, int grade);

    // 2 代表DDC采集，1 代表串口通信
    List<ChillersEntity> queryChillersDDC(int grade);

    // 批量插入历史流水表
    void batchInsertChillersHistory(List<ChillersEntity> chillersEntityLists);

    // 根据DDC地址和寄存器地址获取到最近采集的时间
    String queryLastChillersHistory(ChillersEntity chillersEntity);

    // 通过DDC地址查询对应的采集参数设备
    List<String> queryDDCAddr(String ddcAddr);

}
