package com.mh.user.service.chillers;

import com.mh.user.entity.GatewayManageEntity;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 网关管理服务类
 * author：ljf
 * create—date：2020-05-21
 */
public interface GatewayManageService {

    /**
     * 根据条件查询网关信息
     * @param grade
     * @param operator
     * @return
     */
    List<GatewayManageEntity> queryByOther(Integer grade, Integer operator);

    /**
     * 新增或更新网关信息
     * @param gatewayManageEntity
     */
    void addOrUpdateGateWayInfo(GatewayManageEntity gatewayManageEntity);

    // 添加网关设备
    String insertGatewayManage(GatewayManageEntity gatewayManageEntity);

    // 根据网关ID删除网关设备
    void deleteGatewayManageByID(int gatewayID);

    // 根据网关ID查询设备信息
    GatewayManageEntity queryGatewayByID(Long gatewayID);

    // 查询全部
    List<GatewayManageEntity> queryAll();

    // 设备总数
    int queryByOtherCount(int page, int size, int gatewayID);

    // 更新网关管理器的最新连接数据
    void updateGatewayManage(String IP,String port);

    // 更新网关管理器的最新连接数据
    void updateGatewayManage2(String port);

    // 根据grade查询对应的网关路由信息
    GatewayManageEntity queryGatewayByGrade(Long grade);

    //根据端口或者IP或者心跳包查询网关对应的项目名称
    String selectProjectName(String str);
}
