package com.mh.user.service.chillers.impl;

import com.mh.user.mapper.chillers.DealDataMapper;
import com.mh.user.service.chillers.DealDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-07-28
 * @throws ：
 */
@Service
public class DealDataServiceImpl implements DealDataService {

    private final DealDataMapper dealDataMapper;

    @Autowired
    public DealDataServiceImpl(DealDataMapper dealDataMapper) {
        this.dealDataMapper = dealDataMapper;
    }

    @Override
    public void proEnergy(String curDate) {

        dealDataMapper.proEnergy(curDate);
    }

    @Override
    public void proEnergyData(String curDate) {

        dealDataMapper.proEnergyData(curDate);
    }

    @Override
    public void proDataResult(String curDate,String projectID) {

        dealDataMapper.proDataResult(curDate,projectID);
    }

    @Override
    public void proEnergyDaySum(String curDate, String projectID) {
        dealDataMapper.proEnergyDaySum(curDate,projectID);
    }

    @Override
    public void proDeviceState(String curDate) {
        dealDataMapper.proDeviceState(curDate);
    }

    @Override
    public void proAnalysisMonth(String curDate) {
        dealDataMapper.proAnalysisMonth(curDate);
    }

    @Override
    public void proAnalysisYear(String curDate) {
        dealDataMapper.proAnalysisYear(curDate);
    }

    @Override
    public void proAlarmInfoSum(String curDate) {
        dealDataMapper.proAlarmInfoSum(curDate);
    }

    @Override
    public void dealData() {
        dealDataMapper.dealData();
    }

    @Override
    public void deleteChillersDataHistory() {
        dealDataMapper.deleteChillersDataHistory();
    }

    @Override
    public void deleteDataHistory() {
        dealDataMapper.deleteDataHistory();
    }

    @Override
    public void saveTempHumidity(String curDate, String ambTemp, String humidity) {
        String strDate=curDate.substring(0,10);
        String strTime=curDate.substring(0,13)+":00:00";
        int count=dealDataMapper.selectDateTempHumidity(strDate);
        if(count==0){
            dealDataMapper.dateTempHumidity(strDate,ambTemp,humidity);
        }else{
            dealDataMapper.updateDateTempHumidity(strDate,ambTemp,humidity);
        }
        count=dealDataMapper.selectHourTempHumidity(strTime);
        if(count==0){
            dealDataMapper.hourTempHumidity(strTime,ambTemp,humidity);
        }else{
            dealDataMapper.updateHourTempHumidity(strTime,ambTemp,humidity);
        }
    }

    @Override
    public List<String> queryProjectId(String systemID) {
        return dealDataMapper.queryProjectId(systemID);
    }
}
