package com.mh.user.service.chillers.impl;

import com.mh.user.entity.GatewayManageEntity;
import com.mh.user.mapper.chillers.GatewayManageMapper;
import com.mh.user.service.chillers.GatewayManageService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ： 网关管理实现类
 * @updateTime 2020-05-21
 * @throws ：
 */
@Service
public class GatewayManageServiceImpl implements GatewayManageService {

    // 通过构造函数注入,引用Mapper
    private final GatewayManageMapper gatewayManageMapper;

    public GatewayManageServiceImpl(GatewayManageMapper gatewayManageMapper) {
        this.gatewayManageMapper = gatewayManageMapper;
    }

    /**
     * 按条件查询网关信息
     * @param grade
     * @param operator
     * @return
     */
    @Override
    public List<GatewayManageEntity> queryByOther(Integer grade, Integer operator) {
        return gatewayManageMapper.queryByOther(grade, operator);
    }

    /**
     * 新增或更新网关信息
     * @param gatewayManageEntity
     */
    @Override
    public void addOrUpdateGateWayInfo(GatewayManageEntity gatewayManageEntity) {
        if(gatewayManageEntity.getType().equals("edit")){
            // 更新
            gatewayManageMapper.updateGateWayInfo(gatewayManageEntity);
        } else if (gatewayManageEntity.getType().equals("add")) {
            // 新增
            gatewayManageMapper.insertGateWayInfo(gatewayManageEntity);
        }
    }
    @Override
    public String insertGatewayManage(GatewayManageEntity gatewayManageEntity) {
        // 判断是否已经包含
        GatewayManageEntity gatewayManageEntity1 = gatewayManageMapper.queryGatewayByID(gatewayManageEntity.getId());
        if (gatewayManageEntity1.getId() != null) {
            return "数据重复，请重新插入";
        } else {
            gatewayManageMapper.insertGatewayManage(gatewayManageEntity);
            return "数据插入成功";
        }
    }

    @Override
    public void deleteGatewayManageByID(int gatewayID) {
        gatewayManageMapper.deleteGatewayManageByID(gatewayID);
    }

    @Override
    public GatewayManageEntity queryGatewayByID(Long gatewayID) {
        return gatewayManageMapper.queryGatewayByID(gatewayID);
    }

    @Override
    public List<GatewayManageEntity> queryAll() {
        return gatewayManageMapper.queryAll();
    }

    @Override
    public int queryByOtherCount(int page, int size, int gatewayID) {
        return gatewayManageMapper.queryByOtherCount(page, size, gatewayID);
    }

    @Override
    public void updateGatewayManage(String IP,String port) {
        gatewayManageMapper.updateGatewayManage(IP,port);
    }

    @Override
    public void updateGatewayManage2(String port) {
        gatewayManageMapper.updateGatewayManage2(port);
    }

    @Override
    public GatewayManageEntity queryGatewayByGrade(Long grade) {
        return gatewayManageMapper.queryGatewayByGrade(grade);
    }

    @Override
    public String selectProjectName(String str) {
        return gatewayManageMapper.selectProjectName(str);
    }
}
