package com.mh.user.service.chillers.impl;

import com.mh.user.entity.ChillersEntity;
import com.mh.user.entity.OrderMessageEntity;
import com.mh.user.mapper.chillers.ChillerControlOrderMapper;
import com.mh.user.service.chillers.OrderMessageService;
import com.mh.user.utils.ExchangeStringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-05-28
 * @throws ：
 */
@Component
@Service
public class OrderMessageServiceImpl implements OrderMessageService {

    private final ChillerControlOrderMapper chillerControlOrderMapper;

    public OrderMessageServiceImpl(ChillerControlOrderMapper chillerControlOrderMapper) {
        this.chillerControlOrderMapper = chillerControlOrderMapper;
    }

    @Override
    public void updateChillersRegisterAddress(String dataStr, String registerAddr) {
        chillerControlOrderMapper.updateChillersRegisterAddress(dataStr, registerAddr);
    }

    @Override
    public void updateOrderMessage(OrderMessageEntity orderMessageEntity) {
        chillerControlOrderMapper.updateOrderMessage(orderMessageEntity);
        // 判断是否是群控指令操作，如果是，更新对应chiller_register_address表中的对应值
        if (orderMessageEntity.getOrderStr().startsWith("00")) {
            if (orderMessageEntity.getRegisterAddr().equalsIgnoreCase("02")
                    || orderMessageEntity.getRegisterAddr().equalsIgnoreCase("04")) {
                orderMessageEntity.setOrderStr(
                        String.valueOf(
                        Double.parseDouble(ExchangeStringUtil.hexToDec(
                        orderMessageEntity.getOrderStr().substring(
                                orderMessageEntity.getOrderStr().length()-4)
                        ))/100)
                );
                chillerControlOrderMapper.updateChillersBySendDDC1(orderMessageEntity);
            } else {
                chillerControlOrderMapper.updateChillersBySendDDC(orderMessageEntity);
            }
        }
    }

    @Override
    public ChillersEntity queryChiller(int id) {
        return chillerControlOrderMapper.queryChiller(id);
    }

    @Override
    public ChillersEntity queryChillerById(int id) {
        return chillerControlOrderMapper.queryChillerById(id);
    }

    @Override
    public void batchInsertOrderMessage(List<OrderMessageEntity> orderMessageEntityList) {
        chillerControlOrderMapper.batchInsertOrderMessage(orderMessageEntityList);
    }

    @Override
    public Date queryCloseChilledLastTime() {
        return chillerControlOrderMapper.queryCloseChilledLastTime();
    }

    @Override
    public void updateChillersBySendDDC(OrderMessageEntity orderMessageEntity) {
        chillerControlOrderMapper.updateChillersBySendDDC(orderMessageEntity);
    }
}
