package com.mh.user.service.impl;

import com.mh.common.http.HttpResult;
import com.mh.user.constants.SysConstants;
import com.mh.user.entity.BuildingEntity;
import com.mh.user.mapper.BuildingMapper;
import com.mh.user.model.BuildingModel;
import com.mh.user.service.BuildingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class BuildingServiceImpl implements BuildingService {

    @Autowired
    private BuildingMapper buildingMapper;

    @Override
    public int saveBuilding(BuildingEntity buildingEntity) {
       return buildingMapper.saveBuilding(buildingEntity);
    }

    @Override
    public int updateBuilding(BuildingEntity buildingEntity) {
       return buildingMapper.updateBuilding(buildingEntity);
    }

    @Override
    public List<BuildingEntity> queryBuilding(String buildingId,int page, int limit) {
        return buildingMapper.queryBuilding(buildingId,page,limit);
    }

    @Override
    public int getCount(String buildingId,int page, int limit) {
        return buildingMapper.getCount(buildingId,page,limit);
    }

    @Override
    public List<BuildingModel> selectBuildingName(){
        return buildingMapper.selectBuildingName();
    }

    //查询楼栋编号
    @Override
    public String selectBuildingId(String buildingName) {
        return buildingMapper.selectBuildingId(buildingName);
    }

    // 删除多个
    @Override
    public int deleteBuilding(List<BuildingEntity> records) {
        for(BuildingEntity record:records) {
            buildingMapper.deleteBuilding(record.getId().toString());
        }
        return 0;
    }

    // 删除单个
    @Override
    public int deleteBuilding(String id) {
        return  buildingMapper.deleteBuilding(id);
    }
}
