package com.mh.user.service.impl;

import com.mh.user.entity.EnergyDataEntity;
import com.mh.user.mapper.EnergyDataMapper;
import com.mh.user.model.EnergyModel;
import com.mh.user.service.EnergyDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class EnergyDataServiceImpl implements EnergyDataService {

    @Autowired
    EnergyDataMapper energyDataMapper;

    @Override
    public List<EnergyDataEntity> queryEnergyData(EnergyModel energyModel) {
        String projectID=energyModel.getProjectID();
        String startDate=energyModel.getStartDate();
        String endDate=energyModel.getEndDate();
        int page=energyModel.getPage();
        int limit=energyModel.getLimit();
        int type=energyModel.getType();
        int queryType=energyModel.getQueryType();

        if (type==1){ //按十分钟
            return energyDataMapper.queryEnergyDataMi(projectID,startDate,page,limit);
        }else if(type==2){ //按小时
            return energyDataMapper.queryEnergyDataHour(projectID,startDate,page,limit);
        }else if(type==3){ //按天
            return energyDataMapper.queryEnergyDataDay(projectID,startDate,queryType,page,limit);
        }else if(type==4){ //按月
            return energyDataMapper.queryEnergyDataMonth(projectID,startDate,queryType,page,limit);
        }else if(type==5){ //按年
            return energyDataMapper.queryEnergyDataYear(projectID,startDate,endDate,queryType,page,limit);
        }else{  //按天，默认
            return energyDataMapper.queryEnergyDataDay(projectID,startDate,queryType,page,limit);
        }
    }

    @Override
    public int getEnergyDataCount(EnergyModel energyModel) {
        String projectID=energyModel.getProjectID();
        String startDate=energyModel.getStartDate();
        String endDate=energyModel.getEndDate();
        int type=energyModel.getType();
        int queryType=energyModel.getQueryType();

        if (type==1){ //按十分钟
            return energyDataMapper.getEnergyDataMiCount(projectID,startDate);
        }else if(type==2) { //按小时
            return energyDataMapper.getEnergyDataHourCount(projectID,startDate);
        }else if(type==3) { //按天
            return energyDataMapper.getEnergyDataDayCount(projectID,startDate,queryType);
        }else if(type==4) { //按月
            return energyDataMapper.getEnergyDataMonthCount(projectID,startDate,queryType);
        }else if(type==5) { //按年
            return energyDataMapper.getEnergyDataYearCount(projectID,startDate,endDate,queryType);
        }else {  //按天，默认
            return energyDataMapper.getEnergyDataDayCount(projectID,startDate,queryType);
        }
    }

}
