package com.mh.user.service.impl;

import com.mh.user.entity.EnergyEntity;
import com.mh.user.mapper.EnergyMapper;
import com.mh.user.model.EnergyParam;
import com.mh.user.service.EnergyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.ArrayList;
import java.util.List;

@Service
public class EnergyServiceImpl implements EnergyService {

    @Autowired
    EnergyMapper energyMapper;

    @Override
    public void saveEnergy(EnergyEntity energyEntity,int type) {

        if(type==1){                            // 保存天
            energyMapper.saveEnergyDay(energyEntity);
        }else if(type==2){                      // 保存月
            energyMapper.saveEnergyMonth(energyEntity);
        }else if(type==3){                      // 保存年
            energyMapper.saveEnergyYear(energyEntity);
        }
    }

    @Override
    public void updateEnergy(EnergyEntity energyEntity,int type) {

        if(type==1){
            energyMapper.updateEnergyDay(energyEntity);
        } else if (type==2){
            energyMapper.updateEnergyMonth(energyEntity);
        } else if (type==3){
            energyMapper.updateEnergyYear(energyEntity);
        }
    }

    @Override
    public void deleteEnergy(String curDate, String buildingId,int type) {

        if(type==1){
            energyMapper.deleteEnergyDay(curDate,buildingId);
        } else if (type==2){
            energyMapper.deleteEnergyMonth(curDate,buildingId);
        } else if (type==3){
            energyMapper.deleteEnergyYear(curDate,buildingId);
        }
    }

    @Override
    public List<EnergyEntity> queryEnergy(EnergyParam energyParam) {
        String projectID=energyParam.getProjectID();
        String buildingId=energyParam.getBuildingId();//所有
        String startDate=energyParam.getStartDate();
        String endDate=energyParam.getEndDate();
        int queryType=energyParam.getQueryType();
        int page=energyParam.getPage();
        int limit=energyParam.getLimit();
        int type=energyParam.getType();

        List<EnergyEntity> list=new ArrayList<EnergyEntity>();
        if(type==1) {
//            list=energyMapper.queryEnergyHour(projectID,buildingId,startDate,queryType,page,limit);
        }else if (type==2){
            list=energyMapper.queryEnergyDay(projectID,buildingId,startDate,endDate,queryType,page,limit);
        }else if (type==3){
            list=energyMapper.queryEnergyMonth(projectID,buildingId,startDate,endDate,queryType,page,limit);
        }else if (type==4){
            list=energyMapper.queryEnergyYear(projectID,buildingId,startDate,endDate,queryType,page,limit);
        }
        return list;
    }

    @Override
    public int getEnergyCount(EnergyParam energyParam) {
        String projectID=energyParam.getProjectID();
        String buildingId=energyParam.getBuildingId();
        String startDate=energyParam.getStartDate();
        String endDate=energyParam.getEndDate();
        int queryType=energyParam.getQueryType();
        int type=energyParam.getType();

        int r=0; // 记录数
        if(type==1) {
            r=energyMapper.getEnergyDayCount(projectID,buildingId,startDate,endDate,queryType);
        }else if (type==2){
            r=energyMapper.getEnergyDayCount(projectID,buildingId,startDate,endDate,queryType);
        }else if (type==3){
            r=energyMapper.getEnergyMonthCount(projectID,buildingId,startDate,endDate,queryType);
        }else if (type==4){
            r=energyMapper.getEnergyYearCount(projectID,buildingId,startDate,endDate,queryType);
        }
        return r;
    }

    @Override
    public List<EnergyEntity> queryEnergyGroup(String curDate, int type) {
        if(type==2) {
            return energyMapper.queryEnergyMonthGroup(curDate);
        }else if (type==3){
            return energyMapper.queryEnergyYearGroup(curDate);
        }else {
            return energyMapper.queryEnergyDayGroup(curDate);
        }
    }

    @Override
    public List<EnergyEntity> queryDayEnergy(String buildingId, String startDate, String endDate, int page, int limit) {
        return energyMapper.queryDayEnergy(buildingId,startDate,endDate,page,limit);
    }

    @Override
    public int getDayEnergyCount(String buildingId, String startDate, String endDate, int page, int limit) {
        return energyMapper.getDayEnergyCount(buildingId,startDate,endDate,page,limit);
    }
}
