package com.mh.user;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mh.user.entity.ReportParamEntity;
import com.mh.user.entity.chart.BaseChartEntity;
import com.mh.user.entity.chart.ChartEntity;
import com.mh.user.entity.chart.Unit;
import com.mh.user.mapper.chart.ChartMapper;
import com.mh.user.service.chart.ChartService;
import com.mh.user.service.chillers.ReportService;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-07-03
 * @throws ：
 */
public class ReportTest1 extends UserServiceApplicationTests {

    @Autowired
    private ReportService reportService;

    @Autowired
    private ChartMapper chartMapper;

    @Autowired
    private ChartService chartService;

    @Test
    public void queryChartData() {
        Map<String,Object> map = new HashMap<>();
        map.put("choose_index_ids","39,69");
        map.put("begin_time","2020-06-15 17:45:00.000");
        map.put("end_time","2020-06-15 18:45:00.000");
        map.put("type",null);
        map.put("chart_id",1);
        List<ChartEntity> chartEntityList = chartService.queryChartData(map);
        System.out.println(JSONArray.toJSONString(chartEntityList));
//        List<BaseChartEntity> baseChartEntityList = chartService.callProChart(map);
//        for (BaseChartEntity baseChartEntity :
//                baseChartEntityList) {
//            System.out.println(baseChartEntity.toString());
//        }
    }

    @Test
    public void queryUnit() {
        Map<String,Object> map = new HashMap<>();
        map.put("choose_index_ids","40,41");
        List<Unit> unitList = chartService.queryUnits(map);
        for (Unit unit :
                unitList) {
            System.out.println(unit.toString());
        }
    }

    @Test
    public void queryAllTarget() {
        List<ReportParamEntity> reportParamEntities = reportService.queryAllTarget("fourWeek");
        List<ReportParamEntity> firstLevel = reportParamEntities.stream().filter(p -> String.valueOf(p.getParentId()).equals("0")).collect(Collectors.toList());
        System.out.println(firstLevel.toString());
        firstLevel.parallelStream().forEach(p -> {
            setChild(p, reportParamEntities);
        });
        JSONObject menuListJson = new JSONObject();
        menuListJson.put("indexInfo",firstLevel);
        System.out.println(menuListJson.toJSONString());
//        for (ReportParamEntity reportParamEntity :
//                reportParamEntities) {
//            System.out.println(reportParamEntity.toString());
//        }
    }

    /**
     * 设置子元素
     * 2018.06.09
     *
     * @param p
     * @param permissions
     */
    private void setChild(ReportParamEntity p, List<ReportParamEntity> permissions) {
//        System.out.println(p.getId());
        List<ReportParamEntity> child = permissions.parallelStream().filter(a -> String.valueOf(a.getParentId()).equals(String.valueOf(p.getId()))).collect(Collectors.toList());
        p.setChildren(child);
        if (!CollectionUtils.isEmpty(child)) {
            child.parallelStream().forEach(c -> {
                //递归设置子元素，多级菜单支持
                setChild(c, permissions);
            });
        }
    }

}
