package com.mh.user.device;

import com.mh.common.http.HttpResult;
import com.mh.user.dto.DeviceMessageDTO;
import com.mh.user.dto.DisplayBoxDataDTO;
import com.mh.user.entity.ChillersEntity;
import com.mh.user.entity.DeviceManageEntity;
import com.mh.user.entity.TableDataEntity;
import com.mh.user.entity.TableInfoEntity;
import com.mh.user.mapper.chillers.ChillersMapper;
import com.mh.user.mapper.chillers.DeviceManageMapper;
import com.mh.user.service.chillers.ChillersService;
import com.mh.user.service.chillers.DeviceDisplayService;
import com.mh.user.service.chillers.DeviceManageService;
import com.mh.user.utils.AnalysisReceiveOrder485;
import com.mh.user.utils.GetReadOrder485;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-05-15
 * @throws ：
 */
@Slf4j
@SpringBootTest
public class DeviceTest {

    @Autowired
    DeviceManageService deviceManageService;


    @Autowired
    DeviceDisplayService deviceDisplayService;

    // 查询设备详情数据
    @Test
    public void queryDeviceDisplay() {
        List<DisplayBoxDataDTO> displayBoxDataDTOList = deviceDisplayService.deviceDisplayBoxData("host",String.valueOf(0));
        for (DisplayBoxDataDTO displayBoxDataDTO :
                displayBoxDataDTOList) {
            log.info(displayBoxDataDTO.toString());
        }
    }

    // 查询设备状态
    @Test
    public void queryDeviceState() {
        List<DeviceMessageDTO> deviceMessageList = deviceDisplayService.queryDeviceStatus("host");
        for (DeviceMessageDTO deviceMessage:
            deviceMessageList){
            log.info(deviceMessage.toString());
        }
    }


    @Test
    public void queryDeviceByOthers() {
        List<DeviceManageEntity> deviceManageEntityList = deviceManageService.queryDeviceByOther(1,10, "88");
        for (DeviceManageEntity deviceManage :
                deviceManageEntityList) {
            log.info(deviceManage.toString());
        }
//        for (int i = 0; i < deviceManageEntityList.size(); i++) {
//            if (deviceManageEntityList.get(i).getDeviceType().equalsIgnoreCase("1")) {      // 1 代表广仪电表
//                // 生成电表指令
//                String meterOrderStr = GetReadOrder485.createMeterOrder("169.254.194.199","8080","2",deviceManageEntityList.get(i).getCollectionNum(),"1");
//                log.info("电表指令------" + meterOrderStr);
//            } else if (deviceManageEntityList.get(i).getDeviceType().equalsIgnoreCase("3")) {      // 3 代表冷量计
//                // 生成电表指令
//                String meterOrderStr = GetReadOrder485.createCloudOrder(deviceManageEntityList.get(i).getCollectionNum(),"34");
//                log.info("冷量计指令------" + meterOrderStr);
//            }
//        }
        int count = deviceManageService.queryDeviceByOtherCount("88");
        log.info("总数： " + count);
    }

    @Autowired
    ChillersService chillersService;

    @Test
    public void queryChillers() {
        List<ChillersEntity> chillersEntityList = chillersService.queryChillersByOther(1,"1");
        for (ChillersEntity chillersEntity :
                chillersEntityList) {
            log.info(chillersEntity.toString());
        }
    }

    @Test
    public void queryChillersByOthers() {
        List<ChillersEntity> chillersEntities = chillersService.queryChillersByOther(1,"1");
        for (ChillersEntity chillersEntity :
                chillersEntities) {
            log.info(chillersEntity.toString());
        }
    }

    @Test
    public void insertChillersEntity() {
        AnalysisReceiveOrder485 analysisReceiveOrder485 = new AnalysisReceiveOrder485();
        ChillersEntity chillersEntity = new ChillersEntity();
        chillersEntity.setDigit(0);
        chillersEntity.setDeviceCode("1");
        chillersEntity.setDeviceNum("1");
        chillersEntity.setFunCode("01");
        chillersEntity.setRegisterAddress("1");
//        analysisReceiveOrder485.analysisChillerOrder485("0303020016404A",chillersEntity);
    }

    @Autowired
    DeviceManageMapper deviceManageMapper;

    @Test
    public void queryByTest() {
        List<DeviceManageEntity> deviceManageEntityList = deviceManageMapper.queryDevicesByType1("manage");
        for (DeviceManageEntity deviceManage :
                deviceManageEntityList) {
            log.info(deviceManage.toString());
        }
    }

    @Autowired
    ChillersMapper chillersMapper;

    @Test
    public void queryTopData() {
        List<TableDataEntity> tableDataEntities = chillersMapper.queryTopData("1号冷水机", 1);
//        for (TableDataEntity tableDataEntity :
//                tableDataEntities) {
//            log.info(tableDataEntity.toString());
//        }

        log.info(""+ HttpResult.ok(tableDataEntities));

        List<TableInfoEntity> tableInfoEntityList = chillersMapper.queryLeftAndRightData("1号冷水机", 1);
//        for (TableInfoEntity tableInfoEntity :
//                tableInfoEntityList) {
//            log.info(tableInfoEntity.toString());
//        }
        log.info(""+HttpResult.ok(tableInfoEntityList));
    }

    // 解析DDC上传的报文
    @Test
    public void batchInsertChillersEntity() throws InterruptedException {
        AnalysisReceiveOrder485 analysisReceiveOrder485 = new AnalysisReceiveOrder485();
        String readStr = "C0 A8 02 0A 1F 90 FF 01 FE 00 00 01 01 00 00 02 00 00 03 00 00 04 00 00 05 00 00 06 00 00 07 00 0B " +
                "08 00 00 09 D7 34 0A 00 01 0B 00 00 0C 00 00 0D 00 00 0E 00 00 0F 00 00 10 00 00 11 00 12 12 00 00 13 D7 80 3E D0";
        analysisReceiveOrder485.analysisChillersDDC(readStr);
    }

    // 通过ddc查询对应的寄存器地址
    @Test
    public void queryDDCAddr() {
        List<String> stringList = chillersMapper.queryDDCAddr("1");
        for (String str :
                stringList) {
            log.info(str);
        }
    }


}
